<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * created        : 14.09.2011
 * created by     : Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate: 2012-10-23 18:16:23 +0200 (Di, 23. Okt 2012) $
 * last changed by: $LastChangedBy: d.mohn $
 * revision       : $LastChangedRevision: 9794 $
 * SVN head URL   : $HeadURL: https://buero-svn.jpberlin.de/Dev-Repository/HMT/GUI/Core/trunk/hpls.hmt.gui.frontend/application/modules/overview/controllers/StatisticsController.php $
 * 
 * author         : Christoph Graupner <c.graupner@heinlein-support.de>
 */
/***/
require_once 'Hpls/Controller/Action.php';
require_once 'Hmt/Log.php';
require_once 'Hmt/Reason.php';

/**
 * @todo comment
 *
 * @author Christoph Graupner <c.graupner@heinlein-support.de>
 * @copyright Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * @package ??
 * @subpackage ??
 * @version $LastChangedRevision: 9794 $
 * @since 1.0.9
 */
class Overview_StatisticsController extends Hpls_Controller_Action {

	function indexAction() {
		try {
			$oldestEntries = Hmt_Log::i()->getOldestEntries();
			$this->view->hmt_log_oldest_connect = empty($oldestEntries['connect']) ? null : $oldestEntries['connect'];
			$this->view->hmt_log_oldest_deliver = empty($oldestEntries['deliver']) ? null : $oldestEntries['deliver'];

			$newestEntries = Hmt_Log::i()->getNewestEntries();
			$this->view->hmt_log_newest_connect = empty($newestEntries['connect']) ? null : $newestEntries['connect'];
			$this->view->hmt_log_newest_deliver = empty($newestEntries['deliver']) ? null : $newestEntries['deliver'];
			
			$stats = Hmt_Log::i()->getStatistics();
			$this->view->hmt_log_size = $stats->getDbSize();
			$this->view->hmt_log_datasets_c = $stats->getTupleCountsConnect();
			$this->view->hmt_log_datasets_d = $stats->getTupleCountsDeliver();
			$this->view->hmt_log_reorg_last = $stats->getLastReorg();
			$this->view->version = Hpls_Application::i()->getVersion();
			$rsn_version = Hmt_Reason::i()->getVersion();
			$this->view->hmt_reason_version = $rsn_version;
			$this->view->license = $this->checkLicense();
		} catch (Zend_Db_Exception $ex) {
			$this->log()->err(__METHOD__. $ex);
//			$this->_redirect($this->getFrontController()->getBaseUrl() . '/config/logdatabase');
		}
	}
	function checkLicense(){
		if(is_file('/opt/heinlein/mailtrace/frontend/license.hmt')){
			return 'Lizensiert';
		} else {
			return 'Keine Lizenz';
		}
	}
}