/**
 * 
 */

function getStateFromPriority(prio) {
	for ( var lState in TEMPLATES.states) {
		if (TEMPLATES.states[lState].prio == prio) {
			return lState;
		}
	}
	return "unknown";
}

/**
 * Construtor
 * 
 * @param config
 *          Object{ "searchFormID": "hmt_form_search", "resultTableID":
 *          "hmt_form_result", // "intervalTime": intervalTime * 1000, //
 *          "intervalReference": new Date(2011, 1, 1), "startTime": new Date(),
 *          "themeUrl": themeUrl }
 */
function ResultController(config) {
	this._config = config;
	this.intervals = null;
	this.resultsMeta = {
	  limit : this._config.limit,
	  offset : 0,
	  query : null,
	  queryId : null,
	  newest : new Date(),
	  oldest : new Date(),
	  reftime: new Date(),
	  qar_counter: -1, // -1 --> um '0' für die erste Abfrage durch getNextQAR()
											// zu erhalten
	  requestStats: {},
	  connectRes: {},
	  deliverRequest: {},
	  queue : {}, // abarbeitungsqueue für vom Server erhaltene Ergebnisse,
	  // aber
	  // noch nicht angezeigte
	  data : {} // angezeigte datenobjekte
	};

	// Hide (Collapse) the toggle containers on load
	// $(".toggleresultcontent").width($(".toggleresultcontent").outerWidth());
	// $(".toggleresultcontent").hide();

	// Slide up and down on click
	// $(".sectionResultsGroup").click(
	// function() {
	// $(this).find('.trace').toggleClass('closed_after').toggleClass(
	// 'opened_after');
	// $(this).children(".toggleresultcontent").slideToggle('slow',
	// function() {
	// $(this).parent().toggleClass('sectionResultsGroupOpened');
	// });
	//
	// // .toggleClass('.opened');
	// });
	// $(".sectionResultsGroup a").click(function(evt) {
	// evt.stopPropagation();
	// });
	//
	// $(".trace").click(function(evt) {
	// evt.preventDefault();
	// });
	$("#result_previous").click(function(evt) {
		resCtrl.requestOlderResults();
	});
	$("#result_next").click(function(evt) {
		resCtrl.requestNewerResults();
	});

	// alert("ready " + baseUrl);
}

/**
 * 
 */
ResultController.prototype = {
init: function() {
	this.resultsMeta.query = this.getRequestUrl();
	this.progress = new HplsProgressPanel({});
	this.progress.addWidget();
	this.loadTemplates();

	$.get(baseUrl + '/' + this._config.searchControllerZF +"/getintervals?format=json", function(ergebnis) {
		if (ergebnis) {
			resCtrl.intervals = ergebnis.intervals;
		}
	});

},

/**
 * @author Christoph Graupner
 */
loadTemplates: function() {
	// alert(this._config.themeUrl + this._config.snippetSection);
	// $.get(this._config.snippet.linklineOlder, function(result) {
	// if (result) {
	// TEMPLATES.linklineOlder = result;
	// }
	// });
	// $.get(this._config.snippet.linklineNewer, function(result) {
	// if (result) {
	// TEMPLATES.linklineNewer = result;
	// }
	// });
// $.get(this._config.snippet.spacingStep, function(result) {
// if (result) {
// TEMPLATES.spacingStep = result;
// }
// });

},

getRequestUrl: function() {
	return $('#' + this._config.searchFormID).serialize(); //
},

/**
 * v.utime v.rdir v.rjump v.rlimit v.roffset v.rpart
 * 
 * @param values
 */
getLinkRequestUrl: function(values) {
	var ret = this.resultsMeta.query;
	for ( var it in values) {
		if (values[it] != 'undefined' && values[it] != null && values[it] != '') {
			if (typeof values[it] == 'object') {
				// time zu ISOtimeStr konvertieren
				ret += '&' + encodeURIComponent(it) + '=' + encodeURIComponent(toISOTimeString(values[it]));
			} else {
				ret += '&' + encodeURIComponent(it) + '=' + encodeURIComponent(values[it]);
			}
		}
	}

	return baseUrl + '/' + this._config.searchControllerZF +'/query?format=json&' + ret;
},

getTableID: function() {
	return '#' + this._resultTableID;
},

handleNoResults: function(results, dirNewer) {
	var qar = 0;
	if (results.qar != null) {
		qar = results.qar;
	}
	var placeholderHtml = $("#ph" + qar);
	if (placeholderHtml.length != 0) {
		placeholderHtml.replaceWith($(TEMPLATES.noresults));
	}
},

processResults: function(results) {
	var dirNewer = false;
	var qar = 0;
	if (results.qar != null) {
		qar = results.qar;
	}
	isDebug && dbgc.info('ProcessResults QAR:',qar);
// if (results.rlimit) {
// this.resultsMeta.limit = results.rlimit;
// }
	dbgc.debug('result: ',results);
	if (results.roffset) {
		this.resultsMeta.requestStats[qar].roffset = results.roffset;
	}
	dbgc.debug('roffset ok');
	if (results.reftime) {
		this.resultsMeta.requestStats[qar].rreftime = hpls.parseDate(results.reftime);
	}
	dbgc.debug('reftime ok');
	
	
	if (results.noresults != null && results.noresults == true) {
		isDebug && dbgc.info(' no results ');
		this.handleNoResults(results, dirNewer);
		this.resultsMeta.requestStats[qar].finished = true;
		this.progress.set(100,'Suche beendet');
		this.progress.hide();
	} else {
		this.progress.set(25,'Verarbeite Einganseinträge...');
		// connects abarbeiten
		if (results.connects != null) {
			isDebug && dbgc.info(' connects ',results.connects);
			this.resultsMeta.requestStats[qar].count += results.connects.length;
			
			results.connects.sort(sortObjByDateDesc); // lexikografischer vergleich
			for ( var i = 0; i < results.connects.length; i++) {
				results.connects[i].time = new Date(results.connects[i].time);
				// @todo connectIDs in request-queue packen
				var cid = this.getConnectID(results.connects[i]);
				this.resultsMeta.requestStats[qar].cids2get[cid] = cid;
			}
			// deliver-request starten
			this.requestDelivers(qar);

			// @todo Sortierung implementieren
			var sectionID = this.getIntervalID(results.connects[0]);
			var content = $('#iv' + sectionID);
			if (content.length == 0) {
				this.addResultSection(sectionID,qar);
				content = $('#iv' + sectionID);
			}

			var rsltGroupHtml = $('#sg'+qar,content);
			var placeholderHtml = $("#ph" + qar, content);
			for ( var i = 0; i < results.connects.length; i++) {
				this.addConnect(results.connects[i], placeholderHtml, dirNewer);
// this.resultsMeta.data[this.getConnectID(results.connects[i])] =
// results.connects[i];
			}
// rsltGroupHtml.addClass('newEntry');
		} else {
			isDebug && dbgc.info(' no connects ');
		
		} // if connects

// this.processDelivers(results);
	} // if noresults-else
	this.updateLinks(qar);
	// allgemeines
	this.updateSearchInfo();
	if (this.resultsMeta.requestStats[qar].error == null && this.resultsMeta.requestStats[qar].finished != true && (this.resultsMeta.requestStats[qar].count < this.resultsMeta.limit)) {
		if (dirNewer) {
			isDebug && dbgc.info( "Should start an other NEWER search.");
			var reqParams = jQuery.extend(true, {}, this.resultsMeta.requestStats[qar].params);
			reqParams.rlimit = this.resultsMeta.limit - this.resultsMeta.requestStats[qar].count;
			isDebug && dbgc.info( "Should start an other NEWER search: "+this.getLinkRequestUrl(reqParams));
			
			// newer
// this.requestNewerResults(rpart, firsttime, rdir, linklineid, rjump, qar,
// roffset, rlimit);
		} else {
			// older
			isDebug && dbgc.info( "Should start an other OLDER search.");
			var reqParams = jQuery.extend(true, {}, this.resultsMeta.requestStats[qar].params);
			reqParams.rlimit = this.resultsMeta.limit - this.resultsMeta.requestStats[qar].count;
			isDebug && dbgc.info( "Should start an other OLDER search: "+this.getLinkRequestUrl(reqParams));
		}
	}
	this.progress.set(50,'Suche zugehörige Ausgangseinträge...');
	this.removePlaceHolder(qar);
},

processDelivers: function(results) {
	// delivers abarbeiten
	this.progress.set(75,'Verarbeite Ausgangseinträge...');
	if (results.delivers != null) {
		dbgc.info("Got Delivers: ",results.delivers);
		// verschachtelung dur Hmt_Log_TransportJson auflösen
		for ( var it in results.delivers) {
			// alert('it: '+it);
			var connectHtml = $('#' + it);
			var cur = results.delivers[it];
			// die eigentlichen DeliverEntries durchgehen
			for ( var j = 0; j < cur.length; j++) {
				cur[j].time = new Date(cur[j].time);
				this.addDeliver(cur[j], connectHtml);
			}
			this.updateEntryStatus(connectHtml);
		}
	} else {
		isDebug && dbgc.warn(' no delivers ');
	
	} // if delivers
	this.progress.set(100,'Suche erfolgreich beendet');
	this.progress.hide();
},

requestDelivers: function(qar) {
	if (this.resultsMeta.requestStats[qar]) {
		var cids = [];
		for(var it in this.resultsMeta.requestStats[qar].cids2get) {
			cids.push(it);
		}
		dbgc.info("Request Delvr for CIDS:",cids);
		
// isDebug && alert(cids);
		var url = baseUrl + '/' + this._config.searchControllerZF +'/getdelivers/format/json/cids/'+encodeURIComponent(cids)+'/qar/'+qar;
	isDebug && dbgc.info("URL: "+url);
	$.ajax({
	  type : 'POST',
	  url : url,
	  dataType : 'json',
	  success : function(result) {
	  	resCtrl.processDelivers(result);
	  },	  	
	  error : function(xhr, status, ex) {
		  isDebug && dbgc.error('GetDeliver error: '+status);
	  }
	});
	} else {
		dbgc.error("No Entry for QAR:",qar);
	}
},

/**
 * @param reftime
 *          Reference-Zeitpunkt, von dem aus die Suche gestartet wird.
 * @param roffset
 *          wenn negativ, dann umgekehrte Suchrichtung
 * @param linklineid
 *          ID, der Linkline, an der der Placeholder eingefügt werden soll
 * @param rjump
 *          Zeit, die zu überspringen ist.
 * @param qar
 *          (QueryAnchorReference) ID der Suchanfrage, die auch zur ID des
 *          Placeholders wird.
 * @param roffset
 * @param rlimit
 */
requestResults: function(reftime, roffset, rlimit, more) {
// return;
	resCtrl.progress.set(0,'Suche Eingangseinträge...');
	resCtrl.progress.show(1000);
	
	dbgc.info("requestResults("+toISOTimeString(reftime)+", "+roffset+","+rlimit+")");
	var rdir = rlimit == null?"older": (rlimit < 0? "newer" : "older");
	more = more == null? {}:more;
	roffset = roffset == null?0:roffset;
	rlimit = rlimit == null?this._config.limit:rlimit;
	reftime = reftime == null?-1:reftime;
	
	var qar = this.getNextQAR();
	more["rreftime"] = reftime;
	more["rdir"] = rdir;
	more["roffset"] = roffset;
	more["rlimit"] = rlimit;
	more["qar"] = qar;

	// qar = qar == null ? 0 : qar;
	this.resultsMeta.requestStats[qar] = {
		params: more, // JSON Object
		cids2get: {},
		cidsGot: {},
		count: 0,
		error: null,
		finshed: false
	};
	var requestUrl = this.getLinkRequestUrl(this.resultsMeta.requestStats[qar].params);
	this.addPlaceHolder(qar,rlimit == null?false: (rlimit < 0? true : false));
// isDebug &&
	window.setTimeout(function () { 	
		isDebug && dbgc.debug("Request: URL\n" + requestUrl);
	$.ajax({
	  type : 'POST',
	  url : requestUrl,
	  dataType : 'json',
	  success : function(results) {
	  	dbgc.info('AJAX success');
	  	resCtrl.processResults(results);
	  },
	  error : function(xhr, status, ex) {
	  	isDebug && dbgc.error('klappt nicht');
	  	resCtrl.handleAjaxError(xhr, status, ex,qar);
	  }	  	
	});
	 }, 1000);
},


handleAjaxError: function(xhr, status, ex, qar) {
  isDebug && dbgc.error('error: ',status,ex);
	this.progress.set(100,'Ein Fehler ist aufgetreten');
	this.progress.hide(5000);  
  this.removePlaceHolder(qar);
  // @todo auch linkline entfernen, wenn dazwischen keine ergebnisse existieren
},

requestUpdates: function(jqSrchGroup) {
	var cids = [];
	this.progress.set(0, 'Suche aktualisierte Datensätze...');
	this.progress.show(1000);
// var qar = jqSrchGroup;
	jqSrchGroup.each(function(i,elem) {
		cids[i] = $(elem).attr('id');
		 var tpl = $(TEMPLATES.wait_animation);
		 	$('.hmt_ph_text',tpl).text('Aktualsiere...');
		$('.hmt_update_state',elem).html(tpl);
	}
	);
// isDebug && alert(cids);
	var qar = 0; // $(jqSrchGroup).find('.hmt_result_list').attr('id');
	isDebug && dbgc.info("URL: "+baseUrl + '/' + this._config.searchControllerZF +'/update/format/json/cids/'+encodeURIComponent(cids)+'/qar/'+qar);
	$.ajax({
	  type : 'POST',
	  url : baseUrl + '/' + this._config.searchControllerZF +'/update/format/json/cids/'+encodeURIComponent(cids)+'/qar/'+qar,
	  dataType : 'json',
	  success : function(result) {
	  	resCtrl.processUpdates(result);
	  },	  	
	  error : function(xhr, status, ex) {
	  	resCtrl.progress.set(100, 'Fehler bei der Aktualisierung.');
	  	resCtrl.progress.hide();
		  isDebug && dbgc.error('UPDATE error: '+status);
	  }
	});
},

processUpdates: function(result) {
	if (result) {
		this.progress.set(50, 'Aktualisiere Ergebnisse...');
		
		var updateTime = toTimeStr(new Date());
		var sgqar = 0;
		if (result.qar != null) {
			sgqar = result.qar;
		}
		isDebug && dbgc.debug('have updates');

		
			// delivers abarbeiten
			if (result.delivers != null) {
				// verschachtelung dur Hmt_Log_TransportJson auflösen
				for ( var it in result.delivers) {
// isDebug && alert('it: '+it);
					var connectHtml = $('#' + it);
					var cur = result.delivers[it];
					// die eigentlichen DeliverEntries durchgehen
					for ( var j = 0; j < cur.length; j++) {
						cur[j].time = new Date(cur[j].time);
						this.addDeliver(cur[j], connectHtml);
					}
					
					this.updateEntryStatus(connectHtml);
				}
			} else {
				isDebug && dbgc.info(' no delivers ');
			
			} // if delivers
			$('.hmt_update_state').each(function(i,elem) {
				$(elem).text('Aktualisiert um '+updateTime);
			});
		
		this.updateLinks(sgqar);
		// allgemeines
		this.updateSearchInfo();
		
	} else {
		isDebug && dbgc.info('no updates');
	}
	this.progress.set(100, 'Aktualisierung abgeschlossen.');
	this.progress.hide();
},

updateSearchInfo: function() {
	var c = $('.hmt_connectentry');
	$('#hmt_results').find('.group_title h2').text('Ergebnisse: '+c.length+' angezeigt');
// $('#hmt_result_view_count').html("<span>" + c.length + "</span>");
	$('.hmt_connectentry:even').removeClass('odd').addClass('even');
	$('.hmt_connectentry:odd').removeClass('even').addClass('odd');
},

updateLinks: function(qar) {
	var placeholderHtml = $('#sg' + qar);
	if (placeholderHtml.length == 0) {
// isDebug &&
		dbgc.error(
				'No placholder for updateLinks');
		return;
	}
// isDebug && alert('updating Links');
	var childCon = placeholderHtml.children('.hmt_connectentry');
	var lastCon = childCon.last().data('obj');
	var firstCon = childCon.first().data('obj');
	var queryMeta = this.resultsMeta.requestStats[qar];
// isDebug && alert('first: ' + firstCon.time + "\nlast: " + lastCon.time);
// var linkUp = $('.hmt_srchgroup_link_up',
// placeholderHtml.parents('.sectionResultsGroup'));
// var linkDn = $('.hmt_srchgroup_link_dn',
// placeholderHtml.parents('.sectionResultsGroup'));
//
// dbgc.debug("here up:\n"+linkUp.html());
	// normale newer-links
// $('a.hmt_njt', linkUp).each(
// function(i, elem) {
// $(elem).click(
// function(e) {
// resCtrl.requestNewerResults(firstCon.pt, toISOTimeString(firstCon.time),
// 'newer','llu'+qar,
// null, resCtrl.makeQAR(resCtrl.getConnectID(firstCon), 'newer',
// $(elem).text()),
// resCtrl.resultsMeta.offset);
// });
// });

	$('a.hmt_srch_next').each(
	    function(i, elem) {
	    	$(elem).attr('title', 'click next -'+$(elem).text()+' M: '+queryMeta.rreftime+ ' O: '+queryMeta.roffset);
	    	$(elem).unbind('click');
		    $(elem).click(
		        function(e) {
		        	dbgc.info('click next -'+$(elem).text()+' M: '+queryMeta.rreftime+ ' O: '+queryMeta.roffset);
		        	resCtrl.requestResults(queryMeta.rreftime, queryMeta.roffset,/* limit */ '-'+$(elem).text());
		        });
		    // $(elem).attr('href',resCtrl.getLinkRequestUrl({rjump:
		    // $(elem).text()}));
	    });
	$('a.hmt_srch_prev').each(
	    function(i, elem) {
	    	$(elem).attr('title', 'click prev '+$(elem).text()+' M: '+queryMeta.rreftime+ ' O: '+queryMeta.roffset);
	    	$(elem).unbind('click');
		    $(elem).click(
		        function(e) {
		        	dbgc.info('click prev');
		        	resCtrl.requestResults(queryMeta.rreftime, queryMeta.roffset,/* limit */ $(elem).text());
		        });
		    // $(elem).attr('href',resCtrl.getLinkRequestUrl({rjump:
		    // $(elem).text()}));
	    });
	
	// jump newer-links
	$('a.hmt_njt').each(
	    function(i, elem) {
	    	$(elem).unbind('click');
		    $(elem).click(
		        function(e) {
		        	resCtrl.requestResults(queryMeta.rreftime, queryMeta.roffset,/* limit */ 25);
		        });
	    });
	// njt == newer jumopt time
	$('a.hmt_njt').each(
		function(i, elem) {
			$(elem).unbind('click');
			$(elem).click(
			function(e) {
				resCtrl.requestResults(queryMeta.rreftime, queryMeta.roffset,/* limit */ '-'+25);
			});
		});
	$('a.hmt_refresh').each(function(i,elem){
		$(elem).unbind('click');
		$(elem).click(
				function(evt) {
					resCtrl.requestUpdates($(this).parents('.sectionResultsGroup').find('.hmt_connectentry'));
				});
	});
},

/**
 * 
 * @param qar
 *          QueryAnchorRef
 * @param direction
 */
addPlaceHolder: function(qar,forward,linklineref) {

// isDebug && alert('addPlaceholder');
	
	if (qar == null) {
		qar='qar0';
		// aller erste suche => placeholder ganz oben
	}
	if (linklineref == null) {
		if (forward) {
			linklineref = 'lluqar0';
		} else {
			linklineref = 'lldqar0';
		}
	}
	dbgc.warn('addPlaceHolder: Forward: ',forward,linklineref);
	
// this.addResultSection()
	var placeHtml = null;
	if (qar == 'qar0') {
		placeHtml= $(TEMPLATES.placeholder_white);
	} else {
		placeHtml= $(TEMPLATES.placeholder);
	}
	
		placeHtml.attr('id', 'ph' + qar);
		var t = $(TEMPLATES.srchgroup);
		t.attr('id','sg'+qar).append(placeHtml);
		
		if (qar == 'qar0') {
// $('#hmt_results_sections').html('<h1>Ich kann nicht mehr</h1>');
			if (forward) {
				t.prependTo("#hmt_results_sections");
			} else {
				t.appendTo("#hmt_results_sections");
			}
		} else {
			if (!forward) {
				$("div.hmt_srchgroup_link_dn").parent().find('.hmt_srchgroup').last().after(t);
				dbgc.warn('addPlaceHolder: adding DOWN');
			} else {
				$("div.hmt_srchgroup_link_up").parent().find('.hmt_srchgroup').first().before(t);
				dbgc.warn('addPlaceHolder: adding UP');
			}
		}
},

removePlaceHolder: function(qar) {
	dbgc.debug("removePH: qar:",qar);
	if (null == qar) {
		qar = "qar0";
	}
	var placeHolder = $('#ph'+qar);
	if (placeHolder.length > 0) {
		placeHolder.remove();
	}
},

/**
 * 
 * @param connectObj
 * @param rsltGroup
 */
addConnect: function(connectObj, rsltGroup, forward) {
	// if (qar != null) {
	// isDebug && alert('have qar: '+qar);
	// }
	// this.resultsMeta.data[connectObj];

	// todo: überprüfung, ob schon vorhanden: beschleunigen
	var cID = this.getConnectID(connectObj);
	if ($('#' + cID).length > 0) {
		return;
	}

	if (rsltGroup != null) {
		var resHtml = $(TEMPLATES.result);
		resHtml.attr("id", this.getConnectID(connectObj));
		$('.hmt_result_c_time', resHtml).html(toTimeStr(connectObj.time));
		var tmp = $('.hmt_result_messageId a', resHtml);
		tmp.text(connectObj.c_mid);
		tmp.attr('href',baseUrl + '/' + this._config.searchControllerZF +'/search/c_msgid/'+encodeURIComponent(connectObj.c_mid));
		// @todo link auf messageId-suche setzen
		var mailEntry = $('.hmt_result_mail_from', resHtml);
		mailEntry.text(connectObj.c_mailfrom);
		mailEntry.attr('href',baseUrl + '/' + this._config.searchControllerZF +'/search/c_mail_from/'+encodeURIComponent(connectObj.c_mailfrom));
		
		$('.hmt_explain_link',resHtml).attr('href',baseUrl+'/mailtrace/explain/show/cid/'+this.getConnectID(connectObj));
		$('.hmt_protocol_link',resHtml).attr('href',baseUrl+'/mailtrace/protocol/show/cid/'+this.getConnectID(connectObj));
		
		// Sektionen für die Sendestatuse einfügen
		var x = $('.hmt_result_mail_to',resHtml);
		for(var it in TEMPLATES.states) {
			x.append(TEMPLATES.delivergroup.replace(/\[\[STATE\]\]/gi,it));
		}
// {foreach $states as $state}
// 
// {/foreach}

		
		$('div.hmt_result_mailto_state_unknown').html('<span style="font-style: italic;" class="hmt_mailto_placeholder">Empfänger noch nicht bekannt.</span>');


		// sortiert einfügen
		if (forward) {
			rsltGroup.after(resHtml);
		} else {
			rsltGroup.before(resHtml);
		}
		resHtml.data('obj', connectObj);

	}
},

getConnectSorted: function(rsltGroup, connectObj) {
	
	return rsltGroup;
},

/**
 * 
 * @param iv
 * @param qar
 *          PlaceholderID
 */
addResultSection: function(iv, qar) {
	var iv2 = iv;
	iv = 'iv' + iv;

	// isDebug && alert("addResultSection " + iv);
	// Objektname = new Date(Jahr, Monat, Tag, Stunden, Minuten, Sekunden);
	// isDebug && alert(year+","+month+","+day+","+hour+","+min);
	var time = dateFromInterval(iv2);
	// find next greater Interval

	var end = dateToInterval(new Date());
	// isDebug && alert('Possible START: '+end);
	for ( var it in this.intervals) {
		var possible = this.intervals[it];

		// alert ("Interval: "+possible+" ?= "+iv2+ ' | '+end);
		if (possible < end && possible > iv2) {
			end = possible;
		}
	}
	var endTime = dateFromInterval(end);
	endTime.setTime(endTime.getTime() - 1000);
	// isDebug && alert("EndTime: " + endTime.toString());
	var secHtml = $(TEMPLATES.section);
	secHtml.attr("id", iv);
// var title = time.toLocaleDateString() + ' ' + time.toLocaleTimeString() + ' -
// ';
// if (time.toLocaleDateString() != endTime.toLocaleDateString()) {
// title += endTime.toLocaleDateString() + " ";
// }
// title += endTime.toLocaleTimeString();
// $('.intervalheading span', secHtml).html(title);

	// @todo Sortierlinks anpassen
	// $('.sectionResultsGroup', secHtml).html(TEMPLATES.srchgroup);
	var resSecContainer = $("#hmt_results_sections");
	// prüfen, ob placeholder da sind, die ins innere verschoben werden sollten
	
	var placeHolder = null;
	if (null != qar) {
		placeHolder = $('#ph'+qar).parents('.hmt_srchgroup');
	} else {
		placeHolder = resSecContainer.children('.hmt_srchgroup');
	}
		
	
	if (placeHolder != null && placeHolder.length > 0) {
		// isDebug && alert('a placeholder to be');
		placeHolder.detach();
		$('.hmt_srch_results', secHtml).append(placeHolder);
// $(".sectionResultsGroup .hmt_result_list", secHtml).append(placeHolder);
	} else {
		
	}
	
	$('#result_previous',secHtml).attr('href','Zurück');
	$('#result_next',secHtml).attr('href','Neuer');

	resSecContainer.append(secHtml);

},

/**
 * Fügt einen weiteren Empfänger, der Liste der Empfänger hinzu.
 * 
 * @param deliverObj
 * @param connectHtml
 */
addDeliver: function(deliverObj, connectHtml) {
	// deliver ohne connect wegwerfen
	if (connectHtml.length == 0) {
		return;
	}
// isDebug && alert('connectHtml: '+connectHtml.html());
	// überprüfen, ob deliver schon vorhanden
	if ($('#'+this.getDeliverID(deliverObj),connectHtml).length > 0) {
		return;
	}
	// @todo Die Zeit dürfte nur geupdatet werden, wenn's der neueste stand wäre
	$('.hmt_result_d_time', connectHtml).html(toTimeStr(deliverObj.time));
	var deliverHtml =	this.addDeliverStackSection(connectHtml, deliverObj);
	var emailTracingStack = $(".hmt_tracing .tracingStack", deliverHtml);
	
 this.updateDeliverState(connectHtml, deliverHtml, deliverObj);

	this.addDeliverTraceStep(emailTracingStack, deliverObj);
},

/**
 * 
 * @param connectHtml
 * @param deliverObj
 * @returns
 */
addDeliverStackSection: function(connectHtml, deliverObj) {
	//
	var uid = this.getDeliverTraceID(deliverObj);
	var mailHtml = $('#'+uid,connectHtml);
	if (mailHtml.length == 0) {
		// es gibt noch keinen deliver eintrag
		dbgc.debug('addDeliver(): ',deliverObj);
		mailHtml = $(TEMPLATES.deliver);
		mailHtml.attr('id', this.getDeliverTraceID(deliverObj));
		mailHtml.data('time',deliverObj.time);
		mailHtml.addClass(deliverObj.d_status);
	
		var connectObj = connectHtml.data('obj');
		var mailEntry = $('.hmt_mailto_mail', mailHtml);
		this.replaceReason(deliverObj, connectObj);

		mailHtml.data('obj', deliverObj);
		$('.hmt_mailto_mail .hmt_to_address a', mailHtml)
		.attr('href',baseUrl + '/' + this._config.searchControllerZF +'/search/d_mail_to/'+encodeURIComponent(deliverObj.d_mailto))
		.text(deliverObj.d_mailto);
		if (deliverObj.rtag != null && deliverObj.rtag != '') {
			$('.hmt_mailto_mail .hmt_to_rtag',mailHtml).text('('+deliverObj.rtag+')').show();
		} else {
			$('.hmt_mailto_mail .hmt_to_rtag',mailHtml).hide();
		}
		
		$('a.hmt_to_station_more', mailHtml).click(
		    function() {
		    	var toggleEl = $(this).parents('div.hmt_mailto_station').find('div.hmt_mailto_details');
		    	var display = toggleEl.css('display');
			    toggleEl.toggleClass("toggle");
			    if (display == 'none') {
			    	toggleImg = 'minus';
			    } else {
			    	toggleImg = 'plus';
			    }
			    $(this).find('img').attr('src', baseUrl+'/HPLS/img/bullet_toggle_'+toggleImg+'.png');
		    });
// $('div.hmt_mailto_details',mailHtml).addClass(deliverObj.d_status);
		$('a.hmt_to_station_protocol', mailHtml).attr('href',baseUrl+'/mailtrace/protocol/show/did/'+encodeURIComponent(this.getDeliverID(deliverObj)));
		$('a.hmt_to_station_explain', mailHtml).attr('href',baseUrl+'/mailtrace/explain/show/did/'+encodeURIComponent(this.getDeliverID(deliverObj)));
		$('div.tracingFrom .tracing_time',mailHtml).html(toTimeStr(connectObj.time));
		// @todo tracingtext (reason) werte mit connect ersetzen
		$('div.tracingFrom .tracing_text',mailHtml).html(connectObj.tevt);
		$('div.tracingFrom .from_email',mailHtml).html(connectObj.c_mailfrom);

		// console.log(connectObj);
		// console.log(deliverObj);
		
		$('.tracing_server_to', mailHtml).html(connectObj.c_srvname);
		$('.tracing_server_from', mailHtml).html(connectObj.cl_hn);
		$('.tracing_statemessage', mailHtml).html(TEMPLATES.states[deliverObj.d_status].title);
		
		
// $('.hmt_mailto_station_header', mailHtml).addClass(deliverObj.d_status);
		if (null != TEMPLATES.states[deliverObj.d_status]) {
			var img = $('img.hmt_mailto_status', mailHtml);
			img.attr('src', TEMPLATES.states[deliverObj.d_status].img);
			img.attr('title',TEMPLATES.states[deliverObj.d_status].title);
		}

		var to = $('.hmt_result_mail_to', connectHtml);
		var placeholderText = $('.hmt_mailto_placeholder',to);
		if (placeholderText.length > 0) {
			placeholderText.remove();
		}
		var toState = $('.hmt_result_mailto_state_'+deliverObj.d_status,to);
		if (toState.length == 0) {
			toState = $('.hmt_result_mailto_state_unknown',to);
		}
		dbgc.debug('ul update: ',$('.hmt_mailto_group',toState).length,this.getGroupLimit(deliverObj.d_status));
		if ($('.hmt_mailto_station',toState).length < this.getGroupLimit(deliverObj.d_status)) {
			toState.find('span.hmt_mailto_list').append('<span>'+deliverObj.d_mailto+', </span>');
		} else {
		
		}
		toState.children('.hmt_mailto_group').append(mailHtml);
		
	}

	return mailHtml;
},

/**
 * 
 * @param deliverHtml
 * @param deliverObj
 */
updateDeliverState: function(connectHtml, deliverHtml, deliverObj) {
	// verschieben des Delivers, falls deliverObj das neueste ist und anderen
	// Status hat
	var newestTime = deliverHtml.data('time');
	dbgc.debug('updateDeliverState',newestTime);
	if (newestTime < deliverObj.time) {
		deliverHtml.data('time',deliverObj.time);
		if (false == $('div.hmt_mailto_details',deliverHtml).hasClass(deliverObj.d_status)) {
			// deliver verschieben
			// altes grouping überprüfen ggf. ändern
		}
	}

	var mailToStateGroup = deliverHtml.parent().parent();
	var count = $('.hmt_mailto_station', mailToStateGroup).length;
	var diff = count-this.getGroupLimit(deliverObj.d_status);
	// gruppierung vornehmen, falls limit erreicht && nicht schon vorhanden
	
	if ($('.hmt_mailto_group_marker',mailToStateGroup).length == 0) {
		if (diff > 0) {
			dbgc.info('do grouping for ', diff);
			$('.hmt_mailto_group_more', mailToStateGroup).show().click(function() {
				$(this).siblings('.hmt_mailto_group').toggleClass('toggle');
				$(this).find('.hmt_mailto_list').toggleClass('toggle');
			}).append('<div class="hmt_mailto_group_marker"/>');
			mailToStateGroup.find('.hmt_mailto_group').toggleClass('toggle');
			mailToStateGroup.find('span.hmt_mailto_list').append('<span> ...</span>');
		} else {
			$('.hmt_mailto_group_more',mailToStateGroup).hide();
			mailToStateGroup.find('.hmt_mailto_group').show();
		}
}
	// gruppierung (anzahl) updaten, falls neue hinzu oder welche weg sind
	if (diff > 0) { // != 0 ist wichtig, da sonst bei anzahl == gruppengrenze
									// unnötig ein "mehr" erscheinen würde,
		// obwohl es keine weiteren einträge gibt
	} else {
	}
	mailToStateGroup.find('.hmt_mailto_group_count').text(count);
	
	connectHtml.find('.hmt_result_mailto_count span').text(connectHtml.find('.hmt_mailto_station').length);
},

getGroupLimit: function(status) {
	// TODO wirkliches limit
	if (null == TEMPLATES.states[status]) {
		return 5;
	}
	
	return TEMPLATES.states[status].group_limit;
},

/**
 * 
 * @param tracingStack
 * @param deliverObj
 * @returns
 */
addDeliverTraceStep: function(tracingStack, deliverObj) {
	var station = null;
	var stationTime = null;
	// isDebug && alert("TracingStack "+tracingStack.html());

	$('.hmt_tracing_step', tracingStack).each(function() {
		var time = $(this).data("time");
		// station suchen, die ältere Zeit als deliverObj hat, aber jünger ist
		// als die bisher gefundene
		if (time != null && time >= deliverObj.time && (stationTime == null || stationTime > time)) {
			// isDebug && alert("less Time Obj "+time.toString()+"\nDeliverTime:
			// "+deliverObj.time);
			station = $(this);
			stationTime = time;
		}
	});
	var tracingStation = $(TEMPLATES.tracing.station);
	tracingStation.attr('id',this.getDeliverID(deliverObj));
	tracingStation.data("obj",deliverObj);
	tracingStation.data("time", deliverObj.time);
	// isDebug && alert("station:"+tracingStation.html());
// $('.tracingDifference span', tracingStation).text('<zeit-diff>
// ('+toTimeStr(deliverObj.time)+')');
	$('.tracing_time', tracingStation).text(toTimeStr(deliverObj.time));
	if (null != stationTime) {
		$('.tracing_timediff',tracingStation).text(toTimeDiffStr(deliverObj.time-stationTime));
	} else {
		// erster deliver eintrag -> zeitdifferenz kommt vom connectlog
		var cObj = $('#'+this.getConnectID(deliverObj)).data('obj');
		if (null != cObj) {
			$('.tracing_timediff',tracingStation).text(toTimeDiffStr(deliverObj.time - cObj.time));
			this.replaceReason(deliverObj, cObj);
		} else {
			$('.tracing_timediff',tracingStation).text('0s');			
		}
	}
	
	// console.log('addDeliverTraceStep: deliverObj.tevt:', deliverObj.tevt);
	// console.log('addDeliverTraceStep: deliverObj.d_rsn:', deliverObj.d_rsn);
	// console.log('deliverObj.tevt ? deliverObj.tevt : deliverObj.d_rsn = ', (deliverObj.tevt ? deliverObj.tevt : deliverObj.d_rsn));
	
	$('.tracing_text', tracingStation).html((deliverObj.tevt ? deliverObj.tevt : deliverObj.d_rsn));
	$('.tracing_server_to', tracingStation).html(deliverObj.d_rh);
	$('.tracing_server_from', tracingStation).html(cObj.c_srvname);
	$('.tracing_statemessage', tracingStation).html(TEMPLATES.states[deliverObj.d_status].title);
	
	
	if (null != TEMPLATES.states[deliverObj.d_status]) {
		var img = $('img.hmt_mailto_status', tracingStation);
		img.attr('src', TEMPLATES.states[deliverObj.d_status].img);
		img.attr('title',TEMPLATES.states[deliverObj.d_status].title);
	}
	
	
	
	if (station != null) {
		// isDebug && alert("have station"+station);
		tracingStation.insertBefore(station);
	} else {
		// neueste Station -> auch update des Status
		tracingStack.append(tracingStation);
	}
	return tracingStack;
},

replaceReason: function(deliverObj,connectObj) {
	dbgc.info('replaceReason',deliverObj,connectObj);
	if (!deliverObj.tevt) {
		return;
	}
	var reasonText = deliverObj.tevt;
	var Suche = /\[\[([^\]]+)\]\]/g;
	var Ergebnis;
	var ret = reasonText;
	var replace = '';
	dbgc.info('REASON TEXT aus OBJECT:',reasonText);
	
	// console.log('REASON REPLACE OBJ:');
	// console.log(connectObj);
	
	while (Ergebnis = Suche.exec(reasonText)) {
		dbgc.info(Ergebnis[1]);
		switch(Ergebnis[1]) {
			case 'T:C_CLIENT:IP':
				replace = connectObj.cl_ip;
				break;
			case 'T:C_CLIENT:HOST':
				replace = connectObj.cl_hn;
				break;
			case 'T:C_TIME':
				replace = toTimeStr(connectObj.time);
				break;
			case 'T:C_MID':
			case 'T:C_MSG_ID':
				replace = connectObj.c_mid;
				break;
			case 'T:C_QID':
				replace = connectObj.c_qid;
				break;
			case 'T:C_SRV':
			case 'T:C_SERVER':
			case 'T:C_MXNAME':
				replace = connectObj.c_srv;
				break;
			case 'T:C_SIZE':
				replace = connectObj.c_size;
				break;
			case 'T:C_CLIENT':
				replace = connectObj.cl_hn+'['+connectObj.cl_ip+']';
				break;
			case 'T:C_MAILFROM':
				replace = connectObj.c_mailfrom;
				break;
		}
		
		ret = ret.replace(new RegExp('\\[\\['+Ergebnis[1]+'\\]\\]', "gi"),replace);
	}
	deliverObj.tevt = ret;
	dbgc.info('DlvrObj: ',deliverObj);
// reasonText.replace(/[[([^)])]]/i,function(w,))
},


updateEntryStatus: function(connectHtml) {
	var status = -2;
	var now = toTimeStr(new Date());
	connectHtml.each(function(i,elem){
		$('.hmt_update_state',elem).text('Aktualisiert um '+now);
	});
	$('.hmt_mailto_station', connectHtml).each(function(i, elem) {
		// isDebug && alert("deliver " + i);
		var dlvr = $(this).data('obj');
		if (null != dlvr) {
			// DEBUG - START
			// FEHLER behandlung - nur für debug zwecke, sonst auskommentieren
			if (null == TEMPLATES.states[dlvr.d_status]) {
				isDebug && dbgc.error("Kein State-Template für " + dlvr.d_status);
			} else {
			// DEBUG - END
			if (TEMPLATES.states[dlvr.d_status].prio > status) {
				status = TEMPLATES.states[dlvr.d_status].prio;
			}
			}
		}
		$(this).hover(function(event){
			$(this).css('backgroundColor', '#F8D0AC');
		}, function(event) {
			$(this).css('backgroundColor', 'transparent');
		});
	});
// var stateObj = TEMPLATES.states[getStateFromPriority(status)];
// var img = $('.hmt_connect_status img', connectHtml).get(0);
// img.src = stateObj.img;
// img.title = stateObj.title;
// $('.hmt_connect_status span', connectHtml).html(stateObj.text);
	// isDebug && alert('New status '+status+':'+getStateFromPriority(status)+'
	// '+stateObj.text);
},

getNextQAR: function() {
	this.resultsMeta.qar_counter++;
	return 'qar'+this.resultsMeta.qar_counter;
},

makeQAR: function(reftime, dir, offset) {
	return reftime + '-' + dir + '-' + offset;
},

getConnectID: function(connectObj) {
	if (connectObj.t == 'c') {
		return this.getIntervalID(connectObj) + 'c' + connectObj.c_id;
	} else {
		return this.getIntervalID(connectObj) + 'c' + connectObj.d_dbid;
	}
},

getDeliverID: function(deliverObj) {
	if (deliverObj.t == 'd') {
		return this.getIntervalID(deliverObj) + 'd' + deliverObj.d_id;
	}
	return null;
},

getDeliverTraceID: function(deliverObj) {
	if (deliverObj.t == 'd') {
		var ret = this.getIntervalID(deliverObj)+ 'dq'+ toIdValue(deliverObj.d_mailto);
		
		return  ret;
	}
	return null;
},

getIntervalID: function(connectObj) {
	if (connectObj != null) {
		if (connectObj.pt != null) {
			return connectObj.pt;
		} else if (connectObj.time != null) {
			var time = parseDate(connectObj.time);
			return '' + padInteger(time.getFullYear(), 4) + padInteger(time.getMonth() + 1, 2)
			    + padInteger(time.getDate(), 2) + '000000';
			// + padInteger(time.getHours(), 2) + padInteger(time.getMinutes(),
			// 2)+padInteger(time.getSeconds(), 2);
		} else {
			return null;
		}

	}
	return null;
},

haveDeliver: function(deliverObj) {
	var x = this.resultsMeta.data[this.getConnectID(deliverObj)];
	if (x != null) {
		if (x[this.getDeliverID(deliverObj)] != null) {
			isDebug && dbgc.warn('have deliver already');
			return true;
		}
	}
	return false;
},
haveConnect: function(connectObj) {
	return this.resultsMeta.data[this.getConnectID(deliverObj)] != null;
},

getStatusImg: function(deliverObj) {

},

getConnectObj: function(deliverObj) {
	
}

};
