<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * created        : Aug 14, 2011
 * created by     : Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate$
 * last changed by: $LastChangedBy$
 * revision       : $LastChangedRevision$
 * SVN head URL   : $HeadURL$
 * 
 * author         : Christoph Graupner <c.graupner@heinlein-support.de>
 */
/***/
require_once 'Hmt/Db/Statistics.php';
require_once 'Hpls/Settings.php';

/**
 * @todo comment
 *
 * @author Christoph Graupner <c.graupner@heinlein-support.de>
 * @copyright Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * @package ??
 * @subpackage ??
 * @version $LastChangedRevision$
 * @since 1.0.9
 */
class Hmt_Db_Statistics_Mysql extends Hmt_Db_Statistics {

	const SQL_DB_SIZE = "SHOW TABLE STATUS FROM %s;";	
	
	/* (non-PHPdoc)
	 * @see Hmt_Db_Statistics::getTupleCountsConnect()
	 */
	function getTupleCountsConnect() {
		// TODO performantere Variante entwickeln
		$db = $this->getDb();
		$ret = 0;
		foreach (Hmt_Log::i()->getConnectTables() as $ival) {
			$stm = $db->query('SELECT COUNT(*) FROM ' . $db->quoteIdentifier($ival));
			$ret += (float) $stm->fetchColumn();
		}
		return $ret;
	}

	/* (non-PHPdoc)
	 * @see Hmt_Db_Statistics::getTupleCountsDeliver()
	 */
	function getTupleCountsDeliver() {
		// TODO performantere Variante entwickeln
		$db = $this->getDb();
		$ret = 0;
		foreach (Hmt_Log::i()->getDeliverTables() as $ival) {
			$stm = $db->query('SELECT COUNT(*) FROM ' . $db->quoteIdentifier($ival));
			$ret += (float) $stm->fetchColumn();
		}
		return $ret;
	}

	/* (non-PHPdoc)
	 * @see Hmt_Db_Statistics::getDbSize()
	 */
	function getDbSize() {
		$size = 0;
		$dbCfg = Hpls_Settings::i()->getConfig('hmt.mtlog.storage.db', true, true);
		$dbConfig = $dbCfg->toArray();
		
		
		$ints = Hmt_Log::i()->getIntervals();
		try {
			$db = $this->getDb();
			$query = sprintf(self::SQL_DB_SIZE, $dbConfig['dbname']);
			$stm = $db->query($query);
			foreach ($stm->fetchAll() AS $set){
				$size += $set['Data_length'] + $set['Index_length'];
			}
			
		} catch (Exception $ex) {
			//ein fehler in der DB kommunikation
			Hpls_Utils::log()->err(__METHOD__ . ": $ex");
			return null;
		}
		return $size;
	}

	/* (non-PHPdoc)
	 * @see Hmt_Db_Statistics::getLastReorg()
	 */
	function getLastReorg() {
		// TODO Auto-generated method stub
		return '';
	}

}