<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 * 
 * created        : 28.10.2010
 * created by     : Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate: 2012-05-04 15:02:49 +0200 (Fr, 04. Mai 2012) $
 * last changed by: $LastChangedBy: lazee $
 * revision       : $LastChangedRevision: 9348 $
 * SVN head URL   : $HeadURL: https://buero-svn.jpberlin.de/Dev-Repository/HMT/GUI/Core/trunk/hpls.hmt.gui.libs/Hmt/Log/ConnectEntry.php $
 * 
 * author         : Christoph Graupner <c.graupner@heinlein-support.de>
 */
/***/
require_once 'Hmt/LogAbstract.php';
require_once 'Hpls/I18n/Utils.php';
/**
 * @todo comment
 *
 * @author Christoph Graupner <c.graupner@heinlein-support.de>
 * @copyright Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * @package ??
 * @subpackage ??
 * @version $LastChangedRevision: 9348 $
 * @since 1.0.9
 */
class Hmt_Log_ConnectEntry extends Hmt_LogAbstract {
	protected static $SHORTEN = array(
			Hmt_Db_Consts::F_C_CLIENT_HOST => 'cl_hn',
			Hmt_Db_Consts::F_C_CLIENT_IP => 'cl_ip',
			Hmt_Db_Consts::F_C_MSG_ID => 'c_mid',
			Hmt_Db_Consts::F_C_QUEUE_ID => 'c_qid',
			Hmt_Db_Consts::F_C_MXNAME => 'c_srv',
			'tracing_event' => 'tevt' );

	public function setValues($values) {
		//@todo umbennen des primary-keys solang noch das schema nicht ganz richtig ist
		

		if (isset($values[Hmt_Db_Consts::F_C_ID])) {
			$values['c_id'] = $values[Hmt_Db_Consts::F_C_ID];
			unset($values[Hmt_Db_Consts::F_C_ID]);
		}
		if (isset($values[Hmt_Db_Consts::F_C_TIME])) {
			$values['time'] = $this->toJSdate($values[Hmt_Db_Consts::F_C_TIME]);
			unset($values[Hmt_Db_Consts::F_C_TIME]);
		}
		if (isset($values[Hmt_Db_Consts::F_C_CREATE_TIME])) {
			$values[Hmt_Db_Consts::F_C_CREATE_TIME] = $this->toJSdate($values[Hmt_Db_Consts::F_C_CREATE_TIME]);
		}
		if (isset($values[Hmt_Db_Consts::F_C_MAILFROM_ADR]) && isset($values[Hmt_Db_Consts::F_C_MAILFROM_DOMAIN])) {
			$values[Hmt_Db_Consts::F_C_MAILFROM] = $values[Hmt_Db_Consts::F_C_MAILFROM_ADR] . '@' . $values[Hmt_Db_Consts::F_C_MAILFROM_DOMAIN];
			unset($values[Hmt_Db_Consts::F_C_MAILFROM_ADR]);
			unset($values[Hmt_Db_Consts::F_C_MAILFROM_DOMAIN]);
		}
		$values['t'] = 'c';
		
		//@todo mit leben füllen:
		
		parent::setValues($values);
		$this->{$this->getSaveKey('tracing_event')} = Hpls_I18n_Utils::translateReplace('hmt_detailspane_table_event_connect_from', array(
				'T:C_ID' => $this->c_id,
				'T:C_CLIENT' => $this->getClient(),
				'T:C_TIME' => $this->getTime(),
				'T:C_MAILFROM' => $this->getMailFrom(),
				'T:C_MSG_ID' => $this->getMessageID(),
				'T:C_SIZE' => $this->getSize(),
				'T:C_QID' => $this->getQueueID(),
				'T:C_MXNAME' => $this->getServerName() ));
		
		$this->c_srvname = $this->getServerName();		
		
	}

	/* (non-PHPdoc)
	 * @see Hmt_LogAbstract::getUniqueKey()
	 */
	public function getUniqueKey() {
		return $this->c_id;
	}

	public function getClient() {
		return $this->cl_hn . '[' . $this->cl_ip . ']';
	}

	public function getMailFrom() {
		return $this->c_mailfrom;
	}

	public function getMessageID() {
		return $this->c_mid;
	}

	public function getTime() {
		return $this->time;
	}

	public function getQueueID() {
		return $this->c_qid;
	}

	public function getServer() {
		return $this->c_srv;
	}

	public function getServerName() {
		$s = Hmt_Log::i()->getServer($this->getServer());
		if (!empty($s)) {
			return $s->getName();
		}
		return null;
	}

	public function getUpdateTime() {
		return $this->c_utime;
	}

	public function getSize() {
		return $this->c_size;
	}

	static protected function getSaveKey($key) {
		if (array_key_exists($key, self::$SHORTEN)) {
			return self::$SHORTEN[$key];
		}
		return $key;
	}

}