<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * created        : 14.03.2011
 * created by     : Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate$
 * last changed by: $LastChangedBy$
 * revision       : $LastChangedRevision$
 * SVN head URL   : $HeadURL$
 * 
 * author         : Christoph Graupner <c.graupner@heinlein-support.de>
 */
/***/


/**
 * Hilfsklasse um DeliverEntry nach Connects zu gruppieren und als JSON-Objekt zu schicken.
 * 
 * Die Gruppierung hat den Vorteil, dass alle zu einem Connect gehörenden Delivers zusammenhängend abgearbeitet werden können.
 * 
 * Der geringfühige Overhead für die gruppierende Indexe und zusätzliche Arrays ist das allemal wert.
 *
 * @author Christoph Graupner <c.graupner@heinlein-support.de>
 * @copyright Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * @package ??
 * @subpackage ??
 * @version $LastChangedRevision$
 * @since 1.0.9
 */
class Hmt_Log_TransportJson {

	public function __construct($entries) {
		$this->addDeliver($entries);
	}

	public function addDeliver($entries) {
		if (!is_array($entries))
			$entries = array(
					$entries );
		
		foreach ($entries as $entry) {
			if (isset($this->{$entry->getConnectID()})) {
				$var = $this->{$entry->getConnectID()};
				$var[] = $entry;
				$this->{$entry->getConnectID()} = $var;
			} else {
				$this->{$entry->getConnectID()} = array(
						$entry );
			}
		
		}
	}
}