<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * created        : 09.11.2011
 * created by     : Sebastian Nitzsche <s.nitzsche@heinlein-support.de>
 *
 * last changed   : $LastChangedDate: 2012-02-23 09:06:10 +0100 (Do, 23. Feb 2012) $
 * last changed by: $LastChangedBy: cgr $
 * revision       : $LastChangedRevision: 9236 $
 * SVN head URL   : $HeadURL: https://buero-svn.jpberlin.de/Dev-Repository/HMT/GUI/Core/trunk/hpls.hmt.gui.libs/Hmt/Reason/Exporter/Postgres.php $
 *
 * author         : Sebastian Nitzsche <s.nitzsche@heinlein-support.de>
 */
/**
 */
require_once 'Hmt/Reason/Exporter.php';

class Hmt_Reason_Exporter_Postgres extends Hmt_Reason_Exporter {
	
	const TEMPLATE_NAME = 'pgsql';

	/**
	 *
	 * @return Hmt_Reason_Exporter_Postgres
	 */
	public static function i() {
		if (is_null(self::$_instance)) {
			self::$_instance = new self();
		}
		return self::$_instance;
	}

	/**
	 * Lädt die Template-Dateien aus dem Pfad, der in der components.ini (export.templatepath)
	 * angegeben ist.
	 * 
	 * @return void
	 */
	protected function loadTemplates() {
		$this->_sqlkey = self::TEMPLATE_NAME;
		$frontendPath = realpath(APPLICATION_PATH . '/..');
		$tplPath = $frontendPath . $this->_options['conf']->templatepath;
		
		if (is_dir($tplPath)) {
			$this->_templates[self::TEMPLATE_NAME]['insert.roles'] = file_get_contents($tplPath . '/insert.roles.pqsql.tpl.sql');
			$this->_templates[self::TEMPLATE_NAME]['insert.config'] = file_get_contents($tplPath . '/insert.config.pgsql.tpl.sql');
			$this->_templates[self::TEMPLATE_NAME]['insert.rules'] = file_get_contents($tplPath . '/insert.rules.pqsql.tpl.sql');
			$this->_templates[self::TEMPLATE_NAME]['insert.reasons'] = file_get_contents($tplPath . '/insert.reasons.pgsql.tpl.sql');
			$this->_templates[self::TEMPLATE_NAME]['insert.regex'] = file_get_contents($tplPath . '/insert.regex.pgsql.tpl.sql');
		} else {
			Hpls_Msgs::i()->addGlobalMsg(Hpls_Msgs::MSG_ERROR, 'hmt_reason_export_postgres', "Template Verzeichnis wurde nicht gefunden. ($tplPath)");
		}
	}
}