<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * created        : 11.04.2011
 * created by     : Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate$
 * last changed by: $LastChangedBy$
 * revision       : $LastChangedRevision$
 * SVN head URL   : $HeadURL$
 * 
 * author         : Christoph Graupner <c.graupner@heinlein-support.de>
 */
/***/
require_once 'Hmt/ReasonAbstract.php';

/**
 * @todo comment
 *
 * @author Christoph Graupner <c.graupner@heinlein-support.de>
 * @copyright Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * @package ??
 * @subpackage ??
 * @version $LastChangedRevision$
 * @since 1.0.9
 */
class Hmt_Reason_RegEx extends Hmt_ReasonAbstract {

	public function getRegEx() {
		return $this->regex;
	}

	public function getRuleId() {
		return $this->getRuleIdS() . '-' . $this->getRuleIdT();
	}

	public function getRuleIdS() {
		return intval($this->rule_id);
	}

	public function getRuleIdT() {
		return $this->rule_id_t;
	}

	public function getDescription() {
		return $this->description;
	}

	public function getParamMap() {
		return $this->param_map;
	}

	public function getPriority() {
		return $this->priority;
	}

	public function getParamMapAsArray() {
		if (empty($this->param_map)) {
			return array();
		}
		$ret = array();
		$splits = explode(';', $this->param_map);
		foreach ($splits as $split) {
			$split = trim($split);
			if (empty($split)) {
				continue;
			}
			$s1 = explode('=', $split);
			if (count($s1) != 2) {
				Hpls_Utils::log()->err(__METHOD__ . Hpls_Debug::print_r($this->param_map, ' ParamMap is not in valid syntax.'));
				require_once 'Hpls/Mailtrace/Exception/Reason/Editor.php';
				throw new Hpls_Mailtrace_Exception_Reason_Editor('ParamMap is not in valid syntax.', Hpls_Consts0::ERR_REASON_PARAMMAP_SYNTAX_INVALID);
			}
			
			$ret[intval(trim($s1[0]))] = Hpls_Utils::str_deqoute(trim($s1[1]));
		}
		return $ret;
	}
}