<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * created        : 07.06.2011
 * created by     : Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate$
 * last changed by: $LastChangedBy$
 * revision       : $LastChangedRevision$
 * SVN head URL   : $HeadURL$
 * 
 * author         : Christoph Graupner <c.graupner@heinlein-support.de>
 */
/**
 */
require_once 'Hpls/Acl/ZendExtend.php';

/**
 *
 * @todo comment
 *      
 * @author Christoph Graupner <c.graupner@heinlein-support.de>
 * @copyright Copyright (c) Heinlein Professional Linux Support GmbH
 *           
 * @package ??
 * @subpackage ??
 * @version $LastChangedRevision$
 * @since 1.0.9
 */
class Hpls_Acl_Acl extends Hpls_Acl_ZendExtend {
	
	public function addRole(Zend_Acl_Role_Interface $role, $parents = null) {
		parent::addRole($role,$parents);
		isDebug('acl') && Hpls_Utils::log()->debug(__METHOD__.Hpls_Debug::print_r($this->_roleRegistry,'ROLES'));
	}

	public function toDot() {
		return "digraph ACL {\n" . $this->getGraph($this->_resources) . "}\n";
	}

	protected function getGraph($start) {
		$ret = '';
		foreach ($start as $res) {
			$parentName = str_replace(array('/','.'), array('ROOT', '_'), $res['instance']->getResourceId());
			$ret .= $parentName . ' [label="' . $res['instance']->getResourceId() . '"];' . "\n";
			foreach ($res['instance']->getValues() as $priv => $v) {
				$ret.= $parentName.'__'.$priv.' [shape=box,label="'."$priv: $v".'"];'."\n";
				$ret.= "$parentName -> ${parentName}__${priv} [style=dotted]\n";
			}
			foreach ($res['children'] as $child => $x) {
					$ret .= "$parentName -> " . str_replace(array('/','.'), array('ROOT', '_'), $child) . ";\n";
			}
		}
		return $ret;
	}

}