<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * created   : Jan 22, 2010
 * created by: Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate: 2011-12-28 17:05:55 +0100 (Mi, 28. Dez 2011) $
 * last changed by: $LastChangedBy: cgr $
 * revision       : $LastChangedRevision: 9196 $
 * SVN head URL   : $HeadURL: https://buero-svn.jpberlin.de/Dev-Repository/AC/GUI/Core/trunk/hpls.ac.core2.gui.libs/Hpls/Controller/Action.php $
 *
 */
/***/
require_once 'Zend/Controller/Action.php';
require_once 'Hpls/Utils.php';
require_once 'Hpls/Configuration/Factory.php';
/**
 * Basis für alle HPLS-Action-Controller
 * @todo comment
 *
 * @author Christoph Graupner <c.graupner@heinlein-support.de>
 * @copyright Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * @package HPLS
 * @subpackage subpackage
 * @version $LastChangedRevision: 9196 $
 * @since 
 *
 */
class Hpls_Controller_Action extends Zend_Controller_Action {
	private $_logger = NULL;

	/**
	 * @todo comment
	 * Assign a request parameter value with name $varName to a view variable with the same name.
	 * 
	 * Usefull for transfering states throw a site call.
	 * 
	 * @param string $varName
	 * @param mixed $default
	 */
	protected function reassign($varName, $default = null) {
		$this->view->assign($varName, $this->getRequest()->getParam($varName, $default));
	}

	protected function reassignAll() {
		foreach ($this->getRequest()->getParams() as $k => $v) {
			if ($k !== Hpls_Constraint_Consts::REQ_KEY_RESULTS) {
				$this->view->assign($k, $v);
			}
		}
	}

	protected function addValueError(array &$value, $errorText) {
		if ($errorText instanceof Exception) {
			$value['error'] = $errorText->getMessage();
		} else {
			$value['error'] = $errorText;
		}
		return $value;
	}

	protected function isConstraintError() {
		$r = $this->getRequest()->getParam(Hpls_Consts::CONSTRAINTS_RESULTS_REQUESTKEY, null);
		if (is_null($r) || !is_object($r))
			return false;
		if (!isset($r->__count__))
			return false;
		if (isset($r->__count__->ERROR) && $r->__count__->ERROR > 0)
			return true;
		return false;
	}

	/**
	 * @todo comment
	 * @return Zend_Log
	 */
	protected function getLogger() {
		if (NULL === $this->_logger) {
			$this->_logger = Hpls_Utils::log();
		}
		return $this->_logger;
	}

	/**
	 * @todo comment
	 * @return Zend_Log
	 */
	protected function log() {
		if (NULL === $this->_logger) {
			$this->_logger = Hpls_Utils::log();
		}
		return $this->_logger;
	}

	/**
	 * Enter description here ...
	 * @param unknown_type $serviceName
	 * @return Hpls_Configuration_ConfigurationInterface
	 */
	protected function getConfigService($serviceName) {
		return Hpls_Configuration_Factory::i()->getService($serviceName);
	}

	/**
	 * @todo comment
	 * @param unknown_type $roleName
	 * @deprecated use forwardRequiredRole() instead
	 */
	protected function redirectRequiredRole($roleName) {
		$this->forwardRequiredRole($roleName);
	}

	protected function forwardRequiredRole($roleName) {
		$this->_forward('rolerequired', 'login', 'auth', array(
				'requiredRole' => $roleName ));
	}

}