<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 * 
 * created        : 15.10.2010
 * created by     : Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate$
 * last changed by: $LastChangedBy$
 * revision       : $LastChangedRevision$
 * SVN head URL   : $HeadURL$
 * 
 * author         : Christoph Graupner <c.graupner@heinlein-support.de>
 */
/***/
require_once 'Hpls/Controller/Plugin/Abstract.php';

/**
 * Authentifizierungsplugin für den Frontendcontroller, der den Login der Appliance nutzt.
 *
 * @author Christoph Graupner <c.graupner@heinlein-support.de>
 * @copyright Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * @package ??
 * @subpackage ??
 * @version $LastChangedRevision$
 * @since Magdeburg:Produktiv2
 */
class Hpls_Controller_Plugin_AuthenticationMailapp extends Hpls_Controller_Plugin_Abstract {
	
	/**
	 * @var Zend_Auth
	 */
	private $_auth = NULL;

	function __construct() {
		$this->_auth = Zend_Auth::getInstance();
	}

	public function dispatchLoopStartup(Zend_Controller_Request_Abstract $request) {
		$module = $this->getRequest()->getModuleName();
		$controller = $this->getRequest()->getControllerName();
		$action = $this->getRequest()->getActionName();
		
		if (FALSE === $this->_auth->hasIdentity()) {
			require_once 'Zend/Controller/Action/Helper/Redirector.php';
			Hpls_Application::i()->getFrontController()->setBaseUrl('');
			$redirect = new Zend_Controller_Action_Helper_Redirector();
			$redirect->setPrependBase(false);
			$route = array(
					'/mailtrace',
					$module,
					$controller,
					$action );
			$redirect->gotoSimpleAndExit('login', 'authentication', 'admin', array(
					'pageFrom' => urlencode(implode('/', $route)) ));
		}
		
		$roles = Hpls_Acl::i()->getCurrentUserRoles();
		if (FALSE === in_array('admin', $roles) && FALSE === ($module == 'auth' && $controller == 'login' && $action == 'rolerequired')) {
			$request->setActionName('rolerequired');
			$request->setControllerName('login');
			$request->setModuleName('auth');
			$request->setParams(array(
					'requiredRole' => 'admin' ));
		}
	}

}