<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 * 
 * created        : 01.10.2010
 * created by     : Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate: 2011-12-28 17:05:55 +0100 (Mi, 28. Dez 2011) $
 * last changed by: $LastChangedBy: cgr $
 * revision       : $LastChangedRevision: 9196 $
 * SVN head URL   : $HeadURL: https://buero-svn.jpberlin.de/Dev-Repository/AC/GUI/Core/trunk/hpls.ac.core2.gui.common/Hpls/Executable/ServiceFactory.php $
 * 
 * author         : Christoph Graupner <c.graupner@heinlein-support.de>
 */
/***/
require_once 'Hpls/Ha.php';

/**
 * @todo comment
 *
 * @author author
 * @copyright Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * @package AC
 * @subpackage HA
 * @version $LastChangedRevision: 9196 $
 * @since Magdeburg:Prod1
 */
class Hpls_Executable_ServiceFactory {
	
	protected static $HA_HANDLED = array(
			'dovecot' );
	
	protected static $_instance = null;

	/**
	 * @return Hpls_Executable_ServiceFactory
	 */
	public static function i() {
		if (is_null(self::$_instance)) {
			self::$_instance = new self();
		}
		return self::$_instance;
	}

	/**
	 * @param string $serviceName
	 * @return Hpls_Executable_Service
	 */
	public static function createService($serviceName) {
		return self::i()->create($serviceName);
	}

	protected function __construct() {
	}

	protected function isHAactive() {
		return Hpls_Ha::isHaActive();
	}

	/**
	 * @param string $serviceName
	 * @return Hpls_Executable_Service
	 */
	public function create($serviceName) {
		$serviceName = trim($serviceName);
		$serviceMap = Hpls_Ha::i()->getServiceMapping();
		if ($this->isHAactive() && array_key_exists(strtolower($serviceName), $serviceMap)) {
			$hatypes = Hpls_Ha::i()->whatHaTypeAmI();
			if (count($hatypes) > 1) {
				//@todo implementieren für mehrere
				Hpls_Utils::log()->notice('Hier muss Umgang mit mehr als einem HA-Type implementiert werden. Z.Zt. wird immer NUR der 1. Werte genommen.');
			
		//				throw new Exception('Hier muss Umgang mit mehr als einem HA-Type implementiert werden.');
			}
			if (empty($hatypes) || count($hatypes) == 0) {
				Hpls_Utils::log()->debug(__CLASS__ . ": Creating LSB service wrapper, because no HA type for this host set: '$serviceName'");
				require_once 'Hpls/Executable/ServiceLSB.php';
				return new Hpls_Executable_ServiceLSB($serviceName);
			} else {
				$hatype = strtoupper($hatypes[0]);
				$service = $serviceMap[strtolower($serviceName)]['hatype'];
				Hpls_Utils::log()->debug(__CLASS__ . ":" . Hpls_Debug::print_r($serviceMap, "SERVICE MAP"));
				if (isset($service[$hatype])) {
					Hpls_Utils::log()->debug(__CLASS__ . ": Creating HA service wrapper: '$serviceName/" . $service[$hatype] . "'");
					return $this->createHAService($serviceName, $service[$hatype]);
				} else {
					Hpls_Utils::log()->debug(__CLASS__ . ": Creating LSB service wrapper, because no HA mapping in type '$hatype': '$serviceName'");
					require_once 'Hpls/Executable/ServiceLSB.php';
					return new Hpls_Executable_ServiceLSB($serviceName);
				}
			}
		} else {
			Hpls_Utils::log()->debug(__CLASS__ . ": Creating service wrapper: '$serviceName'");
			require_once 'Hpls/Executable/ServiceLSB.php';
			return new Hpls_Executable_ServiceLSB($serviceName);
		}
	}

	protected function createHAService($serviceName, $hatype) {
		require_once 'Hpls/Executable/ServiceHA.php';
		return new Hpls_Executable_ServiceHA($serviceName, $hatype);
	}
}