<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 * 
 * created        : Oct 3, 2010
 * created by     : Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate: 2011-12-28 17:05:55 +0100 (Mi, 28. Dez 2011) $
 * last changed by: $LastChangedBy: cgr $
 * revision       : $LastChangedRevision: 9196 $
 * SVN head URL   : $HeadURL: https://buero-svn.jpberlin.de/Dev-Repository/AC/GUI/Core/trunk/hpls.ac.core2.gui.common/Hpls/Executable/Wrapper/Cibadmin.php $
 * 
 * author         : Christoph Graupner <c.graupner@heinlein-support.de>
 */
/***/
require_once 'Hpls/Executable/WrapperAbstract.php';

/**
 * @todo comment
 *
 * @author Christoph Graupner <c.graupner@heinlein-support.de>
 * @copyright Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * @package ??
 * @subpackage HA
 * @version $LastChangedRevision: 9196 $
 * @since Magdeburg:Produktiv1
 */
class Hpls_Executable_Wrapper_Cibadmin extends Hpls_Executable_WrapperAbstract {
	const CRM_EXECUTABLE = '/usr/sbin/cibadmin';

	public function __construct() {
		parent::__construct(self::CRM_EXECUTABLE);
		$this->setExecWithSudo();
	
	}

	/**
	 * @todo comment
	 * 
	 * @param string $resID
	 * @return string
	 */
	public function getResourceConfig($resID) {
		isDebug('trace_method_entry') && $this->log()->debug(__METHOD__ . " START");
		//	cibadmin -Q --xpath "//primitive[@id='resIMAP-IP']"
		//		$resID = trim($resID);
		$this->setCommandOptions(array(
				"-Q",
				"--xpath",
				"\"//primitive[@id='$resID']\"" ));
		if (FALSE === $this->exec()) {
			switch ($this->getReturnCode()) {
				case 22 : //resource not exists
					return null;
			}
			require_once 'Hpls/Exception/Executable/Wrapper/Cibadmin.php';
			throw new Hpls_Exception_Executable_Wrapper_Cibadmin(__METHOD__, -1, $this->getCommand(), $this->getCommandOptions());
		}
		$output = implode('', $this->getOutput());
		//		$this->log()->debug(__METHOD__.": output: ".Hpls_Debug::print_r($output));
		return $output;
	}

	/**
	 * @todo comment
	 * 
	 * @return string
	 */
	public function getAllResourceConfig() {
		isDebug('trace_method_entry') && $this->log()->debug(__METHOD__ . " START");
		$this->setCommandOptions(array(
				'-Q',
				'-o',
				'resources' ));
		if (FALSE === $this->exec()) {
			require_once 'Hpls/Exception/Executable/Wrapper/Cibadmin.php';
			throw new Hpls_Exception_Executable_Wrapper_Cibadmin(__METHOD__, -1, $this->getCommand(), $this->getCommandOptions());
		}
		$output = implode('', $this->getOutput());
		return $output;
	}

	public function setAllResourceConfig($resourceConfigXml) {
		if ($resourceConfigXml instanceof SimpleXMLElement) {
			$resourceConfigXml = $resourceConfigXml->asXml();
		
		}
	}

	/**
	 * @todo comment
	 * 
	 * @return string
	 */
	public function getAllConstraints() {
		isDebug('trace_method_entry') && $this->log()->debug(__METHOD__ . " START");
		$this->setCommandOptions(array(
				'-Q',
				'-o',
				'constraints' ));
		if (FALSE === $this->exec()) {
			require_once 'Hpls/Exception/Executable/Wrapper/Cibadmin.php';
			throw new Hpls_Exception_Executable_Wrapper_Cibadmin(__METHOD__, -1, $this->getCommand(), $this->getCommandOptions());
		}
		$output = implode('', $this->getOutput());
		return $output;
	}

	public function setAllConstraints($constraintsXml) {
		isDebug('trace_method_entry') && $this->log()->debug(__METHOD__ . " START");
		if ($constraintsXml instanceof SimpleXMLElement) {
			$constraintsXml = $constraintsXml->asXml();
		}
		$tmpfile = $this->getTmpDir() . '/' . uniqid(__CLASS__);
		if (FALSE === file_put_contents($tmpfile, $constraintsXml)) {
			require_once 'Hpls/Exception/Executable/Wrapper/Cibadmin.php';
			throw new Hpls_Exception_Executable_Wrapper_Cibadmin("Konnte '$tmpfile' nicht schreiben.", 1, null);
		}
		$this->setCommandOptions(array(
				'--replace',
				'--scope',
				'constraints',
				'--xml-file',
				"\"$tmpfile\"" ));
		if (FALSE === $this->exec()) {
			unlink($tmpfile);
			require_once 'Hpls/Exception/Executable/Wrapper/Cibadmin.php';
			throw new Hpls_Exception_Executable_Wrapper_Cibadmin("Setzen der Constraints aus '$tmpfile' ist gescheitert.", $this->getReturnCode(), $this->getCommand(), 'localhost', $this->getCommandOptions());
		}
		unlink($tmpfile);
	
		//		$this->log()->debug(Hpls_Debug::print_r($constraintsXml, __METHOD__));
	}

}