<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * created   : Jan 29, 2010
 * created by: Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate: 2010-10-14 12:39:09 +0200 (Do, 14. Okt 2010) $
 * last changed by: $LastChangedBy: cgr $
 * revision       : $LastChangedRevision: 7268 $
 * SVN head URL   : $HeadURL: https://buero-svn.jpberlin.de/Dev-Repository/HMT/GUI/Core/trunk/hpls.hmt.gui.libs/Hpls/Mailtrace/Model/Log/Interface.php $
 *
 */
/***/

require_once 'Hpls/Var/Clause.php';

/**
 * @todo comment
 *
 * @author Christoph Graupner <c.graupner@heinlein-support.de>
 * @copyright Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * @package ??
 * @subpackage ??
 * @version $LastChangedRevision: 7268 $
 * @since rc
 */
interface Hpls_Mailtrace_Model_Log_Interface {
	/**
	 * @todo comment
	 * Prepares the internal SQL, the results can be fetched with getConnectEntries()
	 *
	 * @param array $searchArgs
	 * @param bool $doCount
	 * @return int|NULL Anzahl der gefundenen Einträge
	 */
	public function searchConnectEntries(Hpls_Var_Clause &$searchArgs, $doCount = false);

	/**
	 * @todo comment
	 *
	 * @param unknown_type $searchArgs
	 * @return Mailtrace_Model_LogEntry
	 */
	public function searchDeliverEntries(Hpls_Var_Clause &$searchArgs, $doCount = false);

	/**
	 * @todo comment
	 *
	 * @param array $searchArgs
	 * @param bool $doCount Should the method do a SELECT COUNT(*) to count the result for the query or don't execute SQL? 
	 * @return int Anzahl der gefundenen Einträge
	 */
	public function searchCompleteEntries(Hpls_Var_Clause &$searchArgs, array $constraints = null, $doCount = false);
	
	/**
	 * @todo comment
	 *
	 * @param unknown_type $id
	 * @return Mailtrace_Model_LogEntry
	 */
	public function getConnectEntry($id);
	
	/**
	 * @todo comment
	 *
	 * @param unknown_type $ids
	 * @return Mailtrace_Model_LogEntry
	 */
	public function getConnectEntries($from=null,$count=null);
	
	/**
	 * @todo comment
	 *
	 * @param unknown_type $ids
	 * @return Mailtrace_Model_LogEntry
	 */
	public function getDeliverEntries($from=null,$count=null);
	
	/**ee
	 * @return array<Mailtrace_Model_LogEntry>
	 */
	public function getCompleteEntries($from=null,$count=null);

	/**
	 * @todo comment
	 *
	 * @return int
	 */
	public function getConnectCount();

	/**
	 * @todo comment
	 *
	 * @param unknown_type $id
	 * @return Mailtrace_Model_LogEntry
	 */
	public function getDeliverEntry($id);
	
	/**
	 * @todo comment
	 *
	 * @return int
	 */
	public function getDeliverCount();
	
	/**
	 * @todo comment
	 *
	 * @param unknown_type $id
	 * @return Mailtrace_Model_LogEntry
	 */
	public function getCompleteEntry(array $searchArgs);

	
	public function getServers();
	
	public function getServer(array $searchArgs);
	
	public function getReasons($from=null,$count=100);
}