<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * created   : Jan 29, 2010
 * created by: Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate: 2012-06-08 12:06:19 +0200 (Fr, 08. Jun 2012) $
 * last changed by: $LastChangedBy: lazee $
 * revision       : $LastChangedRevision: 9442 $
 * SVN head URL   : $HeadURL: https://buero-svn.jpberlin.de/Dev-Repository/HMT/GUI/Core/trunk/hpls.hmt.gui.libs/Hpls/Mailtrace/Model/Log/Storage/Db/Abstract.php $
 *
 */
/**
 *
 */
require_once 'Hpls/Mailtrace/Model/Log/Storage/Interface.php';
require_once 'Zend/Db.php';
require_once 'Zend/Db/Select.php';
require_once 'Hpls/Utils.php';
require_once 'Hpls/Mailtrace/Model/Entry/LogEntry.php';
require_once 'Hpls/Mailtrace/Model/Entry/ServerEntry.php';
abstract class Hpls_Mailtrace_Model_Log_Storage_Db_Abstract implements 
	Hpls_Mailtrace_Model_Log_Storage_Interface {
	const F_C_ID = 'dbid';
	const F_C_CLIENT = 'c_client';
	const F_C_MAILFROM = 'c_mailfrom';
	const F_C_MSG_ID = 'c_messageid';
	const F_C_SIZE = 'c_size';
	const F_C_QUEUE_ID = 'c_queueid';
	const F_C_MXNAME = 'c_server';
	const F_C_TIME = 'c_time';
	const F_D_ID = 'id';
	const F_D_REF_C_ID = 'd_dbid';
	const F_D_MAILTO = 'd_mailto';
	const F_D_STATUS = 'd_status';
	const F_D_REASON = 'd_reason';
	const F_D_RELAYHOST = 'd_relayhost';
	const F_D_QUEUE_ID = 'd_queueid';
	const F_D_TIME = 'd_time';
	const F_D_SERVER = 'd_server';
	const F_S_ID = 'id';
	const F_S_NAME = 's_name';
	const CFG_USERNAME = MTConsts::CONF_STORAGE_DB_USER;
	const CFG_PASSWORD = MTConsts::CONF_STORAGE_DB_PASSWORD;
	const CFG_DBNAME = MTConsts::CONF_STORAGE_DB_NAME;
	const CFG_DBHOST = MTConsts::CONF_STORAGE_DB_HOST;
	const CFG_DBPORT = MTConsts::CONF_STORAGE_DB_PORT;
	const TABLE_CONNECT = 'connectlog';
	const TABLE_DELIVER = 'deliverlog';
	const TABLE_SERVER = 'servers';
	protected static $SEARCH2FIELD = array(
			MTConsts::SRCH_C_DATE_FROM => self::F_C_TIME,
			MTConsts::SRCH_C_ID => self::F_C_ID,
			MTConsts::SRCH_MAILFROM => self::F_C_MAILFROM,
			MTConsts::SRCH_MAILTO => self::F_D_MAILTO,
			MTConsts::SRCH_C_DATE_TO => self::F_C_TIME,
			MTConsts::SRCH_D_DATE_FROM => self::F_D_TIME,
			MTConsts::SRCH_D_DATE_TO => self::F_D_TIME,
			MTConsts::SRCH_MX => self::F_C_MXNAME,
			MTConsts::SRCH_RELAY_HOST => self::F_D_RELAYHOST,
			MTConsts::SRCH_CLIENT => self::F_C_CLIENT,
			MTConsts::SRCH_C_QUEUE_ID => self::F_C_QUEUE_ID,
			MTConsts::SRCH_D_QUEUE_ID => self::F_D_QUEUE_ID,
			MTConsts::SRCH_MSG_ID => self::F_C_MSG_ID,
			MTConsts::SRCH_STATUS => self::F_D_STATUS,
			MTConsts::SRCH_REASON => self::F_D_REASON,
			MTConsts::SRCH_SIZE => self::F_C_SIZE );
	protected static $DELIVER_FIELD_MAP = array(
			Hpls_Mailtrace_Model_Entry_DeliverInterface::ATTR_D_ID => self::F_D_ID,
			Hpls_Mailtrace_Model_Entry_DeliverInterface::ATTR_D_REF_C_ID => self::F_D_REF_C_ID,
			Hpls_Mailtrace_Model_Entry_DeliverInterface::ATTR_D_MAILTO => self::F_D_MAILTO,
			Hpls_Mailtrace_Model_Entry_DeliverInterface::ATTR_D_STATUS => self::F_D_STATUS,
			Hpls_Mailtrace_Model_Entry_DeliverInterface::ATTR_D_REASON => self::F_D_REASON,
			Hpls_Mailtrace_Model_Entry_DeliverInterface::ATTR_D_RELAYHOST => self::F_D_RELAYHOST,
			Hpls_Mailtrace_Model_Entry_DeliverInterface::ATTR_D_QUEUE_ID => self::F_D_QUEUE_ID,
			Hpls_Mailtrace_Model_Entry_DeliverInterface::ATTR_D_TIME => self::F_D_TIME,
			Hpls_Mailtrace_Model_Entry_DeliverInterface::ATTR_D_SERVER_ID => self::F_D_SERVER );
	protected static $CONNECT_FIELD_MAP = array(
			Hpls_Mailtrace_Model_Entry_ConnectInterface::ATTR_C_ID => self::F_C_ID,
			Hpls_Mailtrace_Model_Entry_ConnectInterface::ATTR_C_CLIENT => self::F_C_CLIENT,
			Hpls_Mailtrace_Model_Entry_ConnectInterface::ATTR_C_MAILFROM => self::F_C_MAILFROM,
			Hpls_Mailtrace_Model_Entry_ConnectInterface::ATTR_C_MSG_ID => self::F_C_MSG_ID,
			Hpls_Mailtrace_Model_Entry_ConnectInterface::ATTR_C_SIZE => self::F_C_SIZE,
			Hpls_Mailtrace_Model_Entry_ConnectInterface::ATTR_C_QUEUE_ID => self::F_C_QUEUE_ID,
			Hpls_Mailtrace_Model_Entry_ConnectInterface::ATTR_C_SERVER_ID => self::F_C_MXNAME,
			Hpls_Mailtrace_Model_Entry_ConnectInterface::ATTR_C_TIME => self::F_C_TIME );
	
	protected static $_FieldCount = 0;
	protected $_whereClause = NULL;
	protected $_orderBy = NULL;
	/**
	 * @var Zend_Db_Statement_Interface
	 */
	protected $_lastStatement = NULL;
	/**
	 * @var Zend_Db_Select
	 */
	protected $_lastSelect = NULL;
	protected $_lastSQLBinds = array();
	protected $_lastResult = NULL;
	protected $_lastSQL = NULL;
	protected $_searchArgs = NULL;
	protected $_selectClause = NULL;
	protected $_searchConstraints = null;
	/**
	 * @var Zend_Db_Adapter_Abstract
	 */
	protected $db = null;

	protected function __construct($adapter, array $adapterParams) {
		$this->db = Zend_Db::factory($adapter, $adapterParams);
	}

	protected function quoteIdentifier($identifier) {
		return $this->db->quoteIdentifier($identifier);
	}

	public function searchCompleteEntries(Hpls_Var_Clause &$searchArgs, array $constraints = null, $doCount = false) {
		$this->_searchArgs = $searchArgs;
		$this->_searchConstraints = $constraints;
		$dbSelect = $this->db->select();
		$dbSelect->from(array(
				'c' => self::TABLE_CONNECT ))->joinLeft(array(
				'd' => self::TABLE_DELIVER ), "c." . $this->quoteIdentifier(self::F_C_ID) . " = d." . $this->quoteIdentifier(self::F_D_REF_C_ID));
		$sql = $this->generateSQLwhere($dbSelect, $searchArgs);
		if (!empty($sql)) {
			$dbSelect->where($sql['sql']);
			$this->_lastSQLBinds = $sql['values'];
		} else {
			$this->_lastSQLBinds = array();
		}
		
		$dbSelect->reset(Zend_Db_Select::COLUMNS);
		$dbSelect->reset(Zend_Db_Select::LIMIT_COUNT);
		$dbSelect->reset(Zend_Db_Select::LIMIT_OFFSET);
		$dbSelect->reset(Zend_Db_Select::ORDER);
		$ret = null;
		if ($doCount === true) {
			$dbSelect->columns('COUNT(*)');
			//			$this->getLogger()->debug("SQL COUNT(): $sql");
			$this->_lastStatement = $this->db->query($dbSelect, $this->_lastSQLBinds);
			$ret = $this->_lastStatement->fetchColumn();
		}
		$this->_lastSelect = $dbSelect;
		$this->getLogger()->debug("Search-SQL: $dbSelect ;## values: " . print_r($this->_lastSQLBinds, true));
		return $ret;
		//		$this->_lastStatement->
	}

	public function getCompleteEntries($from = null, $count = null) {
		$dbSelect = $this->_lastSelect;
		if (empty($dbSelect))
			throw new Hpls_Mailtrace_Exception_Usage("No DB query present. Possibly forgot to call searchCompleteEntries() before.");
		$dbSelect->reset(Zend_Db_Select::COLUMNS);
		$dbSelect->reset(Zend_Db_Select::LIMIT_COUNT);
		$dbSelect->reset(Zend_Db_Select::LIMIT_OFFSET);
		$dbSelect->reset(Zend_Db_Select::ORDER);
		$dbSelect->limit($count, $from);
		$dbSelect->columns('c.*')->columns('d.*');
		$constraints = $this->_searchConstraints;
		if (!empty($constraints[MTConsts::RESOPT_SORT_COL])) {
			$sortCol = $constraints[MTConsts::RESOPT_SORT_COL];
			if ($sortCol != MTConsts::RESOPT_SORT_COL_VAL_NOSORT) {
				$sortAsc = $constraints[MTConsts::RESOPT_SORT_ASC];
				if (is_array($sortCol)) {
				} else {
					$sortCol = array(
							$sortCol );
				}
				if (!empty($sortAsc) && $sortAsc) {
					$sortAsc = Zend_Db_Select::SQL_ASC;
				} else {
					$sortAsc = Zend_Db_Select::SQL_DESC;
				}
				foreach ($sortCol as $col) {
					$dbSelect->order($this->mapModelDbField($col, true) . " $sortAsc");
				}
			}
		}
		$this->getLogger()->debug("Get-SQL: $dbSelect \n;## values: " . print_r($this->_lastSQLBinds, true));
		$this->_lastStatement = $this->db->query($dbSelect, $this->_lastSQLBinds);
		$results = $this->_lastStatement->fetchAll();
		$ret = array();
		foreach ($results as $result) {
			$result = array_change_key_case($result, CASE_LOWER);
			$entry = $this->convertRawToConnectEntry($result);
			$entry = $this->convertRawToDeliverEntry($result, $entry);
			$ret[] = $entry;
		}
		return $ret;
	}

	public function getCompleteEntry(array $searchArgs) {
		$select = $this->db->select();
		$select->from(array(
				'c' => self::TABLE_CONNECT ))->joinLeft(array(
				'd' => self::TABLE_DELIVER ), "c." . $this->quoteIdentifier(self::F_C_ID) . " = d." . $this->quoteIdentifier(self::F_D_REF_C_ID));
		if (array_key_exists(MTConsts::SRCH_C_ID, $searchArgs) && !empty($searchArgs[MTConsts::SRCH_C_ID])) {
			$select->where(sprintf('c.%s = %s', $this->quoteIdentifier(self::F_C_ID), $this->quote($searchArgs[MTConsts::SRCH_C_ID])));
		}
		if (array_key_exists(MTConsts::SRCH_D_ID, $searchArgs) && !empty($searchArgs[MTConsts::SRCH_D_ID])) {
			$select->where(sprintf('d.%s = %s', $this->quoteIdentifier(self::F_D_ID), $this->quote($searchArgs[MTConsts::SRCH_D_ID])));
		}
		$select->limit(1);
		$this->getLogger()->debug("getCompletetEntry(): SQL: $select");
		//'SELECT `c`.*, `d`.* FROM `connectlog` AS `c` LEFT JOIN `deliverlog` AS `d` ON c.`DBID` = d.`D_DBID` LIMIT 1'
		$stmt = $this->db->query($select);
		$results = $stmt->fetchAll();
		if (empty($results)) {
			//no connect, no deliver -> finished here
			$this->getLogger()->debug("getCompletetEntry(): no results for '$select'");
			return null;
		}
		$ret = array();
		foreach ($results as $result) {
			$result = array_change_key_case($result, CASE_LOWER);
			$entry = $this->convertRawToConnectEntry($result);
			$entry = $this->convertRawToDeliverEntry($result, $entry);
			$ret[] = $entry;
		}
		return $ret;
	}

	public function searchConnectEntries(Hpls_Var_Clause &$searchArgs, $doCount = false) {
		$select = $this->db->select();
		$select->from(self::TABLE_CONNECT);
	}

	public function searchDeliverEntries(Hpls_Var_Clause &$searchArgs, $doCount = false) {
	}

	public function getConnectEntries($from = null, $count = null) {
	}

	public function getConnectEntry($id) {
		$sql = sprintf('SELECT * FROM %s AS d WHERE d.%s = %s', self::TABLE_CONNECT, self::F_C_ID, $this->quote($id));
		$stmt = $this->db->query($sql);
		$result = $stmt->fetchAll();
		if (count($result) > 0) {
			$ret = array();
			foreach ($result as $k => $row) {
				$row = array_change_key_case($row, CASE_LOWER);
				$ret[] = $this->convertRawToConnectEntry($row);
			}
			return $ret;
		}
		return NULL;
	}

	public function getConnectCount() {
		$sql = 'SELECT COUNT(*) FROM ' . self::TABLE_CONNECT;
		$stmt = $this->db->query($sql);
		$result = $stmt->fetchOne($sql);
		return $result;
	}

	public function getDeliverEntries($from = null, $count = null) {
	}

	public function getDeliverEntry($id) {
		$sql = sprintf('SELECT * FROM %s AS d WHERE d.%s = %s', self::TABLE_DELIVER, self::F_D_ID, $this->quote($id));
		$stmt = $this->db->query($sql);
		$result = $stmt->fetchAll();
		if (count($result) > 0) {
			$ret = array();
			foreach ($result as $k => $row) {
				$row = array_change_key_case($row, CASE_LOWER);
				$ret[] = $this->convertRawToDeliverEntry($row);
			}
			return $ret;
		}
		return NULL;
	}

	public function getDeliverCount() {
		$sql = 'SELECT COUNT(*) FROM ' . self::TABLE_DELIVER;
		$stmt = $this->db->query($sql);
		$result = $stmt->fetchColumn();
		return $result;
	}

	public function getDeliverForConnect($connectID) {
		$sql = sprintf('SELECT * FROM %s AS d WHERE d.%s = %s', self::TABLE_DELIVER, self::F_D_REF_C_ID, $this->quote($connectID));
		$stmt = $this->db->query($sql);
		$result = $stmt->fetchAll();
		if (count($result) > 0) {
			$ret = array();
			foreach ($result as $k => $row) {
				array_change_key_case($row, CASE_LOWER);
				$ret[] = $this->convertRawToDeliverEntry($row);
			}
			return $ret;
		}
	}

	public function proprietarySearch(Zend_Db_Select &$search) {
	}

	public function getServers() {
		$dbSelect = $this->db->select();
		$dbSelect->from(array(
				's' => self::TABLE_SERVER ));
		//		$dbSelect->reset(Zend_Db_Select::COLUMNS);		
		//		$this->getLogger()->debug("getServers(): SQL: $dbSelect");
		$statement = $this->db->query($dbSelect);
		$results = $statement->fetchAll();
		$ret = array();
		foreach ($results as $result) {
			$result = array_change_key_case($result);
			$entry = $this->convertRawToServerEntry($result);
			$ret[] = $entry;
		}
		
		$ret = $this->serverSort($ret);
		return $ret;
	}

	public function getServer(array $searchArgs) {
		if (empty($searchArgs))
			return null;
		$dbSelect = $this->db->select();
		$dbSelect->from(array(
				's' => self::TABLE_SERVER ));
		$values = array();
		if (!empty($searchArgs[Hpls_Mailtrace_Model_Entry_ServerInterface::ATTR_S_ID])) {
			$dbSelect->where($this->quoteIdentifier('s.' . self::F_S_ID) . " = :server");
			$values[':server'] = $searchArgs[Hpls_Mailtrace_Model_Entry_ServerInterface::ATTR_S_ID];
		} else if (!empty($searchArgs[Hpls_Mailtrace_Model_Entry_ServerInterface::ATTR_S_NAME])) {
			$dbSelect->where($this->quoteIdentifier('s.' . self::F_S_NAME) . " = :server");
			$values[':server'] = $searchArgs[Hpls_Mailtrace_Model_Entry_ServerInterface::ATTR_S_NAME];
		} else {
			//no query arguments -> getServers() is possibly ment
			return null;
		}
//		$this->getLogger()->debug(__METHOD__ . " SQL: $dbSelect");
		$statement = $this->db->query($dbSelect, $values);
		$results = $statement->fetchAll();
		$ret = array();
		foreach ($results as $result) {
			$result = array_change_key_case($result, CASE_LOWER);
			$entry = $this->convertRawToServerEntry($result);
			$ret[] = $entry;
		}
		return $this->serverSort($ret);
	}
	protected function serverSort($array_of_serverobjects) {
		usort($array_of_serverobjects, function($a, $b) {
			$tmp_cmp_a = $a->s_name;
			$tmp_cmp_b = $b->s_name;
			if($tmp_cmp_a == $tmp_cmp_b) return 0;
			return ($tmp_cmp_a < $tmp_cmp_b) ? -1 : 1;
		});		
		return $array_of_serverobjects;
	}
	public function getReasons($from = null, $count = 100) {
		$dbSelect = $this->db->select();
		$dbSelect->from(array(
				'd' => self::TABLE_DELIVER ), array(
				self::F_D_STATUS,
				self::F_D_REASON ));
		$dbSelect->group(array(
				self::F_D_STATUS,
				self::F_D_REASON ));
		$dbSelect->limit($count, $from);
		$this->getLogger()->debug("getReasons-SQL: $dbSelect");
		$statement = $this->db->query($dbSelect);
		$results = $statement->fetchAll();
		$ret = array();
		foreach ($results as $result) {
			$result = array_change_key_case($result, CASE_LOWER);
			$ret[] = $result;
		}
		return $ret;
	}

	protected function genSQLwhereRecursive(Zend_Db_Select &$dbSelect, $mode, array &$clause) {
		$useC = false;
		$useD = false;
		$this->getLogger()->debug("genSQL: " . Zend_Debug::dump($clause, "Doing '$mode': ", false));
		$ret = array();
		//
		foreach ($clause as $key => $v) {
			if ($v instanceof Hpls_Var_Clause) {
				$this->getLogger()->debug("Found subClause '" . $v->getLogic() . "'");
				$subRet = $this->genSQLwhereRecursive($dbSelect, $v->getLogic(), $v->get());
				if (!empty($subRet))
					$ret[] = "($subRet)";
				//				$useC = $useC || $retSub['useC'];
			//				$useD = $useD || $retSub['useD'];
			} else {
				if (!empty($v)) {
					$subRet = $this->genWhereClause2($dbSelect, $this->mapSearch2DbField($key), $v, $key);
					//					$prepared = $this->genPreparedWhereClause($dbSelect, $this->mapSearch2DbField($key), 
					//					$v, $key);
					//					$this->getLogger()->debug("SQL: prepared clause: " . print_r($prepared,true));
					if (!empty($subRet))
						$ret[] = "($subRet)";
				}
			}
		}
		if ($mode === Hpls_Var_Clause::CL_AND) {
			$sqlConcat = ' AND ';
		} elseif ($mode === Hpls_Var_Clause::CL_OR) {
			$sqlConcat = ' OR ';
		}
		return count($ret) === 0 ? null : implode($sqlConcat, $ret);
	}

	protected function genPreparedSQLwhereRecursive(Zend_Db_Select &$dbSelect, $mode, array &$clause) {
		$useC = false;
		$useD = false;
		$this->getLogger()->debug("genPreparedSQL: " . Zend_Debug::dump($clause, "Doing '$mode': ", false));
		$retSQL = array();
		$retValues = array();
		//
		foreach ($clause as $key => $v) {
			if ($v instanceof Hpls_Var_Clause) {
				$this->getLogger()->debug("Found subClause '" . $v->getLogic() . "'");
				$subRet = $this->genPreparedSQLwhereRecursive($dbSelect, $v->getLogic(), $v->get());
				if (!empty($subRet)) {
					$retSQL[] = "(" . $subRet['sql'] . ")";
					$retValues = array_merge($retValues, $subRet['values']);
				}
				//				$useC = $useC || $retSub['useC'];
			//				$useD = $useD || $retSub['useD'];
			} else {
				if (!empty($v)) {
					$prepared = $this->genPreparedWhereClause($dbSelect, $this->mapSearch2DbField($key), $v, $key);
					$this->getLogger()->debug("SQL: prepared clause: " . print_r($prepared, true));
					if (!empty($prepared)) {
						$retSQL[] = "(" . $prepared['sql'] . ")";
						$retValues = array_merge($retValues, $prepared['value']);
					}
				}
			}
		}
		if ($mode === Hpls_Var_Clause::CL_AND) {
			$sqlConcat = ' AND ';
		} elseif ($mode === Hpls_Var_Clause::CL_OR) {
			$sqlConcat = ' OR ';
		}
		$ret = array(
				'sql' => implode($sqlConcat, $retSQL),
				'values' => $retValues );
		$this->getLogger()->debug("PrepSQL: " . print_r($ret, true));
		return count($retSQL) === 0 ? null : array(
				'sql' => implode($sqlConcat, $retSQL),
				'values' => $retValues );
	}

	protected function generateSQLwhere(Zend_Db_Select &$dbSelect, Hpls_Var_Clause &$searchArgs) {
		//markers for used db-tables -> for decision which tables are in FROM clause
		if ($searchArgs->isEmpty())
			return null;
		$clause = $searchArgs->get();
		$t = $this->genPreparedSQLwhereRecursive($dbSelect, $searchArgs->getLogic(), $clause);
		$this->getLogger()->debug("SQL prepared WHERE: " . print_r($t, true));
		return $t; //$this->genSQLwhereRecursive($dbSelect, $searchArgs->getLogic(), $clause);
	}

	/**
	 * @todo comment
	 *
	 * @param unknown_type $date
	 * @return unknown
	 */
	protected function correctDateTo($date) {
		//TODO implement correction to end of day
		return date(DateTime::ISO8601, $date);
	}

	protected function correctDateFrom($date) {
		//TODO implement correction to start of day
		return date(DateTime::ISO8601, $date);
	}

	/**
	 * @todo comment
	 * @param $dbSelect
	 * @param $field
	 * @param $value
	 * @param $searchKey
	 * @return array
	 */
	protected function genPreparedWhereClause(Zend_Db_Select &$dbSelect, $field, $value, $searchKey) {
		$ret = array();
		$sql = null;
		$wildcard = true;
		$op = '=';
		//@todo value between e.g. time		
		if (strncasecmp($field, 'd_', 2) == 0) {
			$sql = 'd.%s %s %s';
			//deliver table
			if (strcasecmp($searchKey, MTConsts::SRCH_D_DATE_FROM) === 0) {
				$op = '>=';
				$value = $this->correctDateFrom($value);
			} elseif (strcasecmp($searchKey, MTConsts::SRCH_D_DATE_TO) === 0) {
				$op = '<=';
				$value = $this->correctDateTo($value);
			} elseif (strcasecmp($searchKey, MTConsts::SRCH_STATUS) === 0) {
				//status === unknown
				if (strcasecmp($value, MTConsts::SRCH_STATUS_UNKNOWN) === 0) {
					//					$op = 'IS NULL';
					//					$value = null;
					$sql = 'd.%s %s'; //remove 3rd '%s', so no value placeholder is added
					$op = 'IS NULL';
					$value = null;
				} else {
					// do nothing -> use defaults from above 
				//					$value = $this->wildCardExpansion($value);
				}
			} else {
				$value = $this->wildCardExpansion($value);
				$op = $value['op'];
				$value = $value['value'];
			}
		} elseif (strncasecmp($field, 'c_', 2) == 0) {
			$sql = 'c.%s %s %s';
			//connect
			if (strcasecmp($searchKey, MTConsts::SRCH_C_DATE_FROM) === 0) {
				$op = '>=';
				$value = $this->correctDateFrom($value);
			} elseif (strcasecmp($searchKey, MTConsts::SRCH_C_DATE_TO) === 0) {
				$op = '<=';
				$value = $this->correctDateTo($value);
			} else {
				$value = $this->wildCardExpansion($value);
				$op = $value['op'];
				$value = $value['value'];
			}
		}
		if (is_array($value)) { //			foreach ()
		}
		self::$_FieldCount++;
		$varField = ":$field" . self::$_FieldCount; //for uniqueness if field is present more than 1 times  
		$ret['sql'] = sprintf($sql, $this->quoteIdentifier($field), $op, $varField);
		if (is_null($value)) {
			$ret['value'] = array();
		} else {
			$ret['value'] = array(
					$varField => $value );
		}
		return $ret;
	}

	/**
	 * @todo comment
	 * @todo implement datum vergleich soll automatisch gehen ohne $searchKey zu übergeben
	 * @param Zend_Db_Select $dbSelect
	 * @param unknown_type $field
	 * @param unknown_type $value
	 * @param unknown_type $searchKey
	 * @return string
	 */
	protected function genWhereClause2(Zend_Db_Select &$dbSelect, $field, $value, $searchKey) {
		$ret = null;
		$sql = null;
		$wildcard = true;
		//@todo value between e.g. time		
		if (strncasecmp($field, 'd_', 2) == 0) {
			//deliver table
			if (strcasecmp($searchKey, MTConsts::SRCH_D_DATE_FROM) === 0) {
				$sql = 'd.%s >= %s';
				$value = $this->correctDateFrom($value);
			} elseif (strcasecmp($searchKey, MTConsts::SRCH_D_DATE_TO) === 0) {
				$sql = 'd.%s <= %s';
				$value = $this->correctDateTo($value);
			} elseif (strcasecmp($searchKey, MTConsts::SRCH_STATUS) === 0) {
				//status === unknown
				if (strcasecmp($value, MTConsts::SRCH_STATUS_UNKNOWN) === 0) {
					$sql = 'd.%s IS NULL';
				} else {
					$sql = 'd.%s = %s';
					$value = $this->quote($value);
					//					$value = $this->wildCardExpansion($value);
				}
			} else {
				$sql = 'd.%s %s %s';
				$value = $this->wildCardExpansion($value);
				return sprintf($sql, $this->quoteIdentifier($field), $value['op'], $this->quote($value['value']));
			}
			$ret = 'd';
		} elseif (strncasecmp($field, 'c_', 2) == 0) {
			//connect
			if (strcasecmp($searchKey, MTConsts::SRCH_C_DATE_FROM) === 0) {
				$sql = 'c.%s >= %s';
				$value = $this->correctDateFrom($value);
			} elseif (strcasecmp($searchKey, MTConsts::SRCH_C_DATE_TO) === 0) {
				$sql = 'c.%s <= %s';
				$value = $this->correctDateTo($value);
			} else {
				$sql = 'c.%s %s %s';
				$value = $this->wildCardExpansion($value);
				return sprintf($sql, $this->quoteIdentifier($field), $value['op'], $this->quote($value['value']));
			}
			$ret = 'c';
		}
		if (is_array($value)) { //			foreach ()
		}
		return sprintf($sql, $this->quoteIdentifier($field), $value);
	}

	protected function wildCardExpansion($text) {
		if ($text === null) {
			return array(
					'op' => 'IS NULL',
					'value' => null );
		}
		$this->getLogger()->debug("regex-1: " . $text);
		//		if (get_magic_quotes_gpc() !== 0) {
		//			$text = stripslashes($text);
		//		}
		$orig = $text;
		$text = str_replace('%', '\\%', $text);
		$this->getLogger()->debug("regex0: " . $text);
		$text = str_replace('_', '\\_', $text);
		$this->getLogger()->debug("regex1: " . $text);
		$text = preg_replace(array(
				'/^\\*/',
				'/([^\\\\])\\*/',
				'/^\\?/',
				'/([^\\\\])\\?/' ), array(
				'%',
				'$1%',
				'_',
				'$1_' ), $text);
		$this->getLogger()->debug("regex2: " . $text);
		$ret = array();
		if (strcmp($orig, $text) === 0) {
			//no wildcard expansion
			$ret['op'] = '=';
		} else {
			$ret['op'] = 'like';
		}
		$ret['value'] = $text;
		//TODO replacement
		$this->getLogger()->debug("wildcard expanded : " . print_r($text, true));
		return $ret;
	}

	protected function quote($text) {
		return $this->db->quote($text);
	}

	function proprietaryGetSelect() {
		return $this->select();
	}

	protected function convertRawToServerEntry(array &$row) {
		$ret = new Mailtrace_Model_ServerEntry();
		$ret->__set(Hpls_Mailtrace_Model_Entry_ServerInterface::ATTR_S_ID, $row[self::F_S_ID]);
		$ret->__set(Hpls_Mailtrace_Model_Entry_ServerInterface::ATTR_S_NAME, $row[self::F_S_NAME]);
		return $ret;
	}

	protected function convertRawToDeliverEntry(array &$row, Mailtrace_Model_LogEntry &$mergeInto = NULL) {
		if (is_null($mergeInto)) {
			/* @var $ret Mailtrace_Model_ConnectEntry */
			$ret = new Mailtrace_Model_LogEntry();
		} else {
			$ret = $mergeInto;
		}
		$ret->__set(Mailtrace_Model_LogEntry::ATTR_D_ID, $row[self::F_D_ID]);
		$ret->__set(Mailtrace_Model_LogEntry::ATTR_D_REF_C_ID, $row[self::F_D_REF_C_ID]);
		$ret->__set(Mailtrace_Model_LogEntry::ATTR_D_MAILTO, $row[self::F_D_MAILTO]);
		$ret->__set(Mailtrace_Model_LogEntry::ATTR_D_STATUS, $row[self::F_D_STATUS]);
		$ret->__set(Mailtrace_Model_LogEntry::ATTR_D_REASON, $row[self::F_D_REASON]);
		$ret->__set(Mailtrace_Model_LogEntry::ATTR_D_RELAYHOST, $row[self::F_D_RELAYHOST]);
		$ret->__set(Mailtrace_Model_LogEntry::ATTR_D_QUEUE_ID, $row[self::F_D_QUEUE_ID]);
		$ret->__set(Mailtrace_Model_LogEntry::ATTR_D_TIME, $row[self::F_D_TIME]);
		$ret->__set(Mailtrace_Model_LogEntry::ATTR_D_SERVER_ID, $row[self::F_D_SERVER]);
		$ret->__set(Mailtrace_Model_LogEntry::ATTR_D_SERVER, $this->getServerFromID($row[self::F_D_SERVER]));
		return $ret;
	}

	protected function convertRawToConnectEntry(array &$row, Mailtrace_Model_LogEntry &$mergeInto = NULL) {
		if (is_null($mergeInto)) {
			/* @var $ret Mailtrace_Model_ConnectEntry */
			$ret = new Mailtrace_Model_LogEntry();
		} else {
			$ret = $mergeInto;
		}
		$ret->__set(Mailtrace_Model_LogEntry::ATTR_C_ID, $row[self::F_C_ID]);
		$ret->__set(Mailtrace_Model_LogEntry::ATTR_C_CLIENT, $row[self::F_C_CLIENT]);
		$ret->__set(Mailtrace_Model_LogEntry::ATTR_C_MAILFROM, $row[self::F_C_MAILFROM]);
		$ret->__set(Mailtrace_Model_LogEntry::ATTR_C_MSG_ID, $row[self::F_C_MSG_ID]);
		$ret->__set(Mailtrace_Model_LogEntry::ATTR_C_SIZE, $row[self::F_C_SIZE]);
		$ret->__set(Mailtrace_Model_LogEntry::ATTR_C_QUEUE_ID, $row[self::F_C_QUEUE_ID]);
		$ret->__set(Mailtrace_Model_LogEntry::ATTR_C_SERVER_ID, $row[self::F_C_MXNAME]);
		$ret->__set(Mailtrace_Model_LogEntry::ATTR_C_SERVER, $this->getServerFromID($row[self::F_C_MXNAME]));
		$ret->__set(Mailtrace_Model_LogEntry::ATTR_C_TIME, $row[self::F_C_TIME]);
		return $ret;
	}

	protected function getServerFromID($id) {
		$res = $this->getServer(array(
				Hpls_Mailtrace_Model_Entry_ServerInterface::ATTR_S_ID => $id ));
		if (empty($res))
			return null;
		return $res[0];
	}

	protected function mapSearch2DbField($searchFieldName) {
		return isset(self::$SEARCH2FIELD[$searchFieldName]) ? self::$SEARCH2FIELD[$searchFieldName] : null;
	}

	protected function mapModelDbField($modelFieldName, $unquoted = false) {
		if (strncasecmp($modelFieldName, 'c_', 2) == 0) {
			$map = $this->getConnectFieldMapping();
			return 'c.' . ($unquoted ? $map[$modelFieldName] : $this->quoteIdentifier($map[$modelFieldName]));
		} else {
			$map = $this->getDeliverFieldMapping();
			return 'd.' . ($unquoted ? $map[$modelFieldName] : $this->quoteIdentifier($map[$modelFieldName]));
		}
	}

	protected static function getDeliverFieldMapping() {
		return self::$DELIVER_FIELD_MAP;
	}

	protected static function getConnectFieldMapping() {
		return self::$CONNECT_FIELD_MAP;
	}

	protected function getLogger() {
		return Hpls_Utils::getLogger();
	}
}
