<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * created        : 18.12.2010
 * created by     : Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate$
 * last changed by: $LastChangedBy$
 * revision       : $LastChangedRevision$
 * SVN head URL   : $HeadURL$
 *
 * author         : Christoph Graupner <c.graupner@heinlein-support.de>
 */
/***/

/**
 * @todo comment
 *
 * @author Christoph Graupner <c.graupner@heinlein-support.de>
 * @copyright Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * @package ??
 * @subpackage ??
 * @version $LastChangedRevision$
 * @since 1.0.7
 */
abstract class Hpls_Protocol_EntryAbstract {
	
	protected $_attributes = array();

	public function __construct($component, $action, $time = NULL) {
		$this->component = $component;
		$this->time = is_null($time) ? time() : strtotime($time);
		$this->action = $action;
	}

	public function __set($varname, $value) {
		$this->_attributes[$varname] = $value;
	}

	public function __isset($varname) {
		return isset($this->_attributes[$varname]);
	}

	public function __unset($varname) {
		if (isset($this->_attributes[$varname])) {
			unset($this->_attributes[$varname]);
		}
	}

	public function __get($varname) {
		return isset($this->_attributes[$varname]) ? $this->_attributes[$varname] : null;
	}

}