<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * created   : Feb 26, 2010
 * created by: Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate: 2011-12-28 17:05:55 +0100 (Mi, 28. Dez 2011) $
 * last changed by: $LastChangedBy: cgr $
 * revision       : $LastChangedRevision: 9196 $
 * SVN head URL   : $HeadURL: https://buero-svn.jpberlin.de/Dev-Repository/AC/GUI/Core/trunk/hpls.ac.core2.gui.libs.smarty/Hpls/Smarty/Plugins/function.paginator.php $
 * 
 * author         : Christoph Graupner <c.graupner@heinlein-support.de>
 *
 */
/***/
require_once 'Hpls/View/Paginator/Paginator.php';

/**
 * Parameter:
 * <ul>
 * <li>paginator: a Hpls_Paginator instance
 * <li>start
 * <li>end
 * <li>count
 * <li>page: current page
 * </ul>
 * @param array $params
 * @param Hpls_Smarty_Smarty $smarty
 */
function smarty_function_paginator(array $params, Smarty_Internal_Template &$smarty) {
	if (!isset($params['value'])) {
		require_once 'Hpls/Exception/Template.php';
		throw new Hpls_Exception_Template("Paginator is missing a Hpls_View_Paginator_Interface as 'value' param.");
	}
	$paginator = $params['value'];
	if (!($paginator instanceof Hpls_View_Paginator_Interface)) {
		require_once 'Hpls/Exception/Template.php';
		throw new Hpls_Exception_Template("Given paginator is not a Hpls_View_Paginator_Interface as 'value' param.");
	}
	$smarty->assign('internPager', $params['value']);
	if (isset($params['formID'])) {
		$smarty->assign('internPagerFormID', $params['formID']);
	}
	if (isset($params['buttonName'])) {
		$smarty->assign('internPagerButtonName', $params['buttonName']);
	}
	$style = 'default';
	if (!empty($params['style'])) {
		$style = trim($params['style']);
	}
	$ret = $smarty->fetch("_paginator/$style.tpl");
	$smarty->clearAssign('internPagerButtonName');
	$smarty->clearAssign('internPagerFormID');
	$smarty->clearAssign('internPager');
	return $ret;
}