<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * created   : Apr 13, 2010
 * created by: Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate: 2011-12-28 17:05:55 +0100 (Mi, 28. Dez 2011) $
 * last changed by: $LastChangedBy: cgr $
 * revision       : $LastChangedRevision: 9196 $
 * SVN head URL   : $HeadURL: https://buero-svn.jpberlin.de/Dev-Repository/AC/GUI/Core/trunk/hpls.ac.core2.gui.libs.smarty/Hpls/Smarty/Plugins/function.zfaction.php $
 * 
 * author         : Christoph Graupner <c.graupner@heinlein-support.de>
 *
 */
/***/
require_once 'Hpls/View/Consts.php';
require_once 'Hpls/Smarty/Smarty.php';

function smarty_function_zfaction(array $params, Smarty_Internal_Template &$smarty) {
	if (count($params) <= 0) {
		$smarty->trigger_error("func.action: no params given.");
	}
	$ret = '';
	
	//link in form of module/controller/action
	$view = $smarty->smarty->getZendView();
	if (!empty($params['a'])) {
		$params['action'] = $params['a'];
		unset($params['a']);
	}
	if (!empty($params['m'])) {
		$params['module'] = $params['m'];
		unset($params['m']);
	}
	if (!empty($params['c'])) {
		$params['controller'] = $params['c'];
		unset($params['c']);
	}
	
	$action = empty($params['action']) ? null : $params['action'];
	$module = empty($params['module']) ? null : $params['module'];
	$controller = empty($params['controller']) ? null : $params['controller'];
	$zfparams = empty($params['params']) ? array() : $params['params'];
	require_once 'Hpls/Utils.php';
	Hpls_Utils::getLogger()->debug("zfaction($action,$controller,$module)");
	
	return $view->action($action, $controller, $module, $zfparams);
}