<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * created   : Jan 19, 2010
 * created by: Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate: 2011-12-28 17:05:55 +0100 (Mi, 28. Dez 2011) $
 * last changed by: $LastChangedBy: cgr $
 * revision       : $LastChangedRevision: 9196 $
 * SVN head URL   : $HeadURL: https://buero-svn.jpberlin.de/Dev-Repository/AC/GUI/Core/trunk/hpls.ac.core2.gui.libs.smarty/Hpls/Smarty/Smarty.php $
 *
 */
/**
 *
 */
define('SMARTY_SPL_AUTOLOAD', 0);
require_once 'Smarty/Smarty.class.php';
require_once 'Hpls/View/Smarty.php'; //included here, so not necessary in plugin function files
require_once 'Hpls/Smarty/ParamNames.php'; //included here, so not necessary in plugin function files


class Hpls_Smarty_Smarty extends Smarty {

	public function assignOrClear(array $params, $varPrefix, $paramName, $scope = Smarty::SCOPE_GLOBAL) {
		if (!empty($params[$paramName]))
			$this->assign($varPrefix . ucfirst($paramName), $params[$paramName], false, $scope);
		else
			$this->clearAssign($varPrefix . ucfirst($paramName));
	}
	
	/**
	 * @var Hpls_View_Smarty
	 */
	protected $zendView = NULL;

	public function __construct() {
		parent::__construct();
	}

	public function isSetVariable($varname) {
		return isset($this->tpl_vars[$varname]);
	}

	public function setZendView(Zend_View_Abstract $view) {
		$this->zendView = $view;
	}

	/**
	 * Pobranie widoku
	 *
	 * @param Zend_View_Abstract obiekt widoku
	 */
	public function getZendView() {
		return $this->zendView;
	}

	public function appendHeadStyle(array $values) {
		$var = $this->getVariable(Hpls_View_Consts::HEAD_STYLES, null, true, false);
		$old = null;
		if ($var instanceof Smarty_Variable) {
			$old = $var->value;
		} else {
			$old = array();
		}
		if ($this->checkDouble($old, $values)) {
			return;
		}
		$old[] = $values;
		$this->assignGlobal(Hpls_View_Consts::HEAD_STYLES, $old);
	}

	public function appendHeadLink(array $values) {
		$var = $this->getVariable(Hpls_View_Consts::HEAD_LINKS, null, true, false);
		$old = null;
		if ($var instanceof Smarty_Variable) {
			$old = $var->value;
		} else {
			$old = array();
		}
		if ($this->checkDouble($old, $values)) {
			return;
		}
		$old[] = $values;
		
		$this->assignGlobal(Hpls_View_Consts::HEAD_LINKS, $old);
	}

	public function appendHeadScript(array $values) {
		$var = $this->getVariable(Hpls_View_Consts::HEAD_SCRIPTS, null, true, false);
		$old = null;
		if ($var instanceof Smarty_Variable) {
			$old = $var->value;
		} else {
			$old = array();
		}
		if ($this->checkDouble($old, $values)) {
			return;
		}
		$old[] = $values;
		$this->assignGlobal(Hpls_View_Consts::HEAD_SCRIPTS, $old);
	}

	public function appendHeadMeta(array $values) {
		$var = $this->getVariable(Hpls_View_Consts::HEAD_METAS, null, true, false);
		$old = null;
		if ($var instanceof Smarty_Variable) {
			$old = $var->value;
		} else {
			$old = array();
		}
		if ($this->checkDouble($old, $values)) {
			return;
		}
		$old[] = $values;
		$this->assignGlobal(Hpls_View_Consts::HEAD_METAS, $old);
	}

	protected function checkDouble(array $old, array $new) {
		foreach ($old as $o) {
			if (count($o) == count($new))
				continue;
			
		//gleiche keys?
			$isec = array_intersect_key($o, $new);
			if (count($new) != count($isec)) {
				continue;
			}
			$found = true;
			foreach ($new as $k => $v) {
				if ($o[$k] != $v) {
					$found = false;
					break;
				}
			}
			if ($found)
				return true;
		}
		return false;
	}

}