<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * created   : Feb 1, 2010
 * created by: Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate: 2011-12-28 17:05:55 +0100 (Mi, 28. Dez 2011) $
 * last changed by: $LastChangedBy: cgr $
 * revision       : $LastChangedRevision: 9196 $
 * SVN head URL   : $HeadURL: https://buero-svn.jpberlin.de/Dev-Repository/AC/GUI/Core/trunk/hpls.ac.core2.gui.libs/Hpls/View/Utils.php $
 *
 */
/**
 *
 */
require_once 'Hpls/View/Consts.php';

class Hpls_View_Utils {

	public static function createTableHeaderItem($id, $title, $active = FALSE, $sortable = FALSE) {
		return array(
				HVConsts::V_T_HEAD_ID => $id,
				HVConsts::V_T_HEAD_TITLE => $title,
				HVConsts::V_T_HEAD_ACTIVE => $active,
				HVConsts::V_T_HEAD_SORTABLE => $sortable );
	}

	/**
	 * @todo comment
	 * - [items][]
	 * - [row*]
	 * - ([active]) => bool
	 * - ([link]) => url or array (module,controller,action,params)
	 * - [values] => mixed
	 * - [value] =>
	 * - [doI18N] => bool*
	 * - [link] => url
	 * @return unknown_type
	 */
	public static function createTableRowItem(array $values, $link = NULL, $active = FALSE) {
		return array(
				HVConsts::V_T_ROW_ACTIVE => $active,
				HVConsts::V_T_ROW_LINK => $link,
				HVConsts::V_T_ROW_COVALUES => $values );
	}

	public static function createTableColItem($value, $doI18N = FALSE, $escapeHTML = false, $link = NULL) {
		return array(
				HVConsts::V_T_COL_VALUE => $value,
				HVConsts::V_T_COL_DOI18N => $doI18N,
				HVConsts::V_T_COL_LINK => $link,
				HVConsts::V_T_COL_ESCAPE => $escapeHTML );
	}
}